
;EIN JUSTIEREN DER UHR WENN SIE ALS QUARZUHR LUFT GEHT NICHT WEGEN DER VIELEN INTERRUPTS !!!        
             
;****************************************************************************************
;*                           GPS-UHR II VON DL3UKH                                      *
;*                           =====================                                      *
;*                                                                                      *
;*--------------------------------------------------------------------------------------*
;*                                                                                      *
;* ALS PIC-IC WURDE GENOMMEN PIC16F88                                                   *
;* ALS OSZILLATOR WURDE DER QUARZ MIT 3,6864MHZ GENOMMEN.(T=0.271SEC ALSO DIE TAKTZEIT)*
;*                                   EIN BEFEHL HAT MEIST 4 TAKTE SIND 1,085SEC        *
;*                                                                                      *
;*--------------------------------------------------------------------------------------*
;*                           BEGINN: 17.10.20                                           *
;*                             ENDE: 03.01.21                                           *        
;****************************************************************************************

        LIST    P=16F88       
        TITLE   "GPS-UHR II"

        ERRORLEVEL -302
        INCLUDE <P16F88.INC>

__CONFIG _CONFIG1, _CP_OFF & _CCPMX_RB0 & _DEBUG_OFF & _WRT_OFF & _CPD_OFF & _LVP_OFF & _BOREN_ON & _MCLRE_OFF & _PWRTE_OFF & _WDTE_OFF & _XT_OSC
__CONFIG _CONFIG2, _IESO_OFF & _FCMEN_OFF

;--------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 22 HEX LOS
;DIES IST ALSO DIE RAM-SPEICHER ZUORDNUNG

;ZEITSCHLEIFE SPEICHERZELLE
HELP                    EQU     0X22       

;LCD SPEICHERZELLEN                    
HELP2                   EQU     0X23
BIT                     EQU     0X24

;RS232
;AUSLESEN
H_H                     EQU     0X25
H_L                     EQU     0X26
MIN_H                   EQU     0X27
MIN_L                   EQU     0X28
SEC_H                   EQU     0X29
SEC_L                   EQU     0X2A
                   
ZAE                     EQU     0X2B    ;//ZAEHLER / STELLE                   

;FUER INTERRUPT
W_STACK                 EQU     0X2C
S_STACK                 EQU     0X2D

;QUARZZEIT TIMER1
QH_H                    EQU     0X2E
QH_L                    EQU     0X2F
QMIN_H                  EQU     0X30
QMIN_L                  EQU     0X31
QSEC_H                  EQU     0X32
QSEC_L                  EQU     0X33
X2                      EQU     0X34  ;BIT7 BEI HIGH 1SEC VORBEI // WEGEN 500MSEC TIMER1 // ALSO MAL 2 
                  
BLINK                   EQU     0X35  ;BIT7 HIGH ES BLINKT ZEIT UEBERNOMMEN
KOMA                    EQU     0X36  ;BIT7 HIGH ZEIT AUS GPS OK UEBERNOMMEN
                                                                  
MIT_PPS                 EQU     0X37  ;WENN DAS PPS-SIGNAL 10SEC FEHLT BLINKT DER DOPPELPUNKT NICHT MEHR                    
 

;FR LAUFSCHRIFT
TXT                     EQU     0X38
ZAE2                    EQU     0X39
LCD_ADR                 EQU     0X3A
NR                      EQU     0X3B
NR_HELP                 EQU     0X3C
ZEILE                   EQU     0X3D
NEU                     EQU     0X3E
AUSWAHL                 EQU     0X3F
MAL                     EQU     0X40    ;WIEVIEL MAL SCHRIFTDRUCHLAUF                 

AUSWAHL_TXT             EQU     0X41    ;LAUFTEXT NACH TASTER AUSWHLEN BIT0 TEXT_0 USW...
 
SYSTEM                  EQU     0X42    ;BIT0 BEI HIGH SOFORT UHR STELLEN MIT GPS-ZEIT 
                                        ;BIT1 BEI HIGH MUSS ES ERST EINMAL GPS-DATEN GELESEN HABEN BIS INTERRUPT FR PPS DIE ZEIT ANZEIGT !!!!!!!!!! NEU GEMACHT
                                        ;BIT2 BEI HIGH 5SEC ZS ZU ENDE BEIM ZEIT-ZONE STELLEN
;FR H-PIEPS EIN/AUS                  
ALARM                   EQU     0X43    ;BIT0 BEI HIGH PIEPS EIN                  
                   
;EEPROM
ADR                     EQU     0X44    ;EEPROM-ADRESSE  -0X30 ALARM EIN/AUS
                   
;MIN HOCH ZAEHLEN BIS 15MIN ODER 30MIN ERREICHT SIND /// AUCH H HOCHZHLEN
ZAE1                    EQU     0X45                     

MERK                    EQU     0X46    ;MERKER FR ANZEIGE ZEIT-ZONE STELLEN
MERK_L                  EQU     0X47
MERK_H                  EQU     0X48

MK                      EQU     0X49    ;HILFSMERKER FUER ZAE1                  

PH                      EQU     0X4A    ;HILFSMERKER FUER PIEPS                      

MERK1                   EQU     0X4B    ;HLIFSZELLE REPEATMERKER BIT0

WECK                    EQU     0X4C    ;BIT0 BEI HIGH WECK-TON EIN
                    
;WECKZEIT
WH_H                    EQU     0X4D
WH_L                    EQU     0X4E
WMIN_H                  EQU     0X4F
WMIN_L                  EQU     0X50
                       
AUS                     EQU     0X51    ;MERKER WECK-SIGNAL BLEIBT AUS
DENK                    EQU     0X52    ;DAMIT PIEPS KOMMT WENN KEINE WECKZEIT                     
                     
SCHNELL                 EQU     0X53    ;SCHNELLER BEI WECKZEIT EINSTELLEN 
                       
                     
;--------------------------- VARIABLEN -------------------------------------
BIT7                    EQU     7       ; BIT 7
BIT6                    EQU     6       ; BIT 6
BIT5                    EQU     5       ; BIT 5
BIT4                    EQU     4       ; BIT 4
BIT3                    EQU     3       ; BIT 3 
BIT2                    EQU     2       ; BIT 2
BIT1                    EQU     1       ; BIT 1 
BIT0                    EQU     0       ; BIT 0
;--------------------------------------------------------------------------
              
;==================================================
;DISPLAY EINSTELLUNG                    
RS                      EQU 1       ; PORTB BIT1 UMSCHALTEN BEFEHL/DATEN      BEI WRITE DATEN IST ES HIGH
EN                      EQU 3       ; PORTB BIT3 ENABLE FALLENDE FLANKE
;==================================================
;==================================================
;LAUFSCHRIFT EINSTELLUNG                      
ANZAHL                  EQU D'8'    ; DISPLAY ZEICHEN ANZAHL
ANZAHL1                 EQU D'9'    ; DISPLAY ZEICHEN ANZAHL PLUS 1
;==================================================
;==================================================                 
BAUD_CONSTANT           EQU D'5'    ;CONSTANT FOR BAUD GENERATOR FOR 9600 BAUD
;BERECHNUNG BEI LOW SPEED  //BRGH=0
;BAUDRATE=FOSZ/(64(BAUD_CONSTANT+1))
;3,6864MHZ/(64(5+1))=3,6864MHZ/384=9600 BAUD
;==================================================
;==================================================          
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

           
;HIER DIE AENDERBAREN EINSTELLUNGEN !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
           
;CODE-ERKENNUNG :
;ICH HABE 2 GPS-MODULE (NEO M6 UND NEO M7) 
;BEIDE LIEFERN UNTERSCHIEDLICHE DATENSAETZE MIT :
; NEO M6 --> $GPRMC,HHMINMINSECSEC USW...
; NEO M7 --> $GNRMC,HHMINMINSECSEC USW...

;EINTRAGEN BEGINNENDES "$" ES KANN AUCH "!" SEIN LAUT INTERNET-SUCHE...
CODE1       EQU     "$"           
       
;DANN WIRD DAS "C" UEBERPRUEFT IN DER 6-TEN STELLE BEI $GPRMC ... UND $GNRMC ...
;ES IST BEI BEIDEN MODULEN AN GLEICHER STELLE
;UND
;KOMMT BEI ANDEREN AUSSENDUNGS-ZEILEN NICHT AN GLEICHER STELLE VOR       
CODE2       EQU     "C"
       
;ES EMPFIEHLT SICH DENNOCH DEN DATEN-SATZ WELCHER VOM GPS-EMPFAENGER KOMMT
;MITTELS COMPUTER AUSZULESEN.... MIT EINEM COMPUTER-PROGRAMM....
;ALSO NUR ZUR UEBERPRUEFUNG....       
       
;-----------------
           
;DIE GPS-UHR LAEUFT NICHT GENAU
;SIE GEHT IMMER ETWAS NACH
           
;HIER DIE ZEIT-KORREKTUR MIT SEC ADDIERUNG
;ES GEHT EINE SEC NACH DANN DIE 1 MIT ' ' EINTRAGEN / ALSO D'1'
;ES GEHT MIT DEM MODUL 2SEC NACH / DANN DIE D'2' EINTRAGEN       
;BIS D'255' WAERE MOEGLICH

;ES WIRD ABER IMMER NUR ADDIERT / NICHT SUBTRAIERT           
KORREKTUR   EQU     D'1'        
   
;DIE NULL D'0' GEHT HIER OBEN AUCH EINZUTRAGEN
;DANN ERFOLGT KEINE ZEITKORREKTUR

;-----------------
;HIER STEHT IN WELCHER SEC DIE UHR AUF GPS-ZEIT GESTELLT WIRD.
       
;BEI "00"SEC WRE ES IN DER 59-TEN SEC / DA DIE KORREKTUR +1SEC OBEN IST 
SEC_STELL_L   EQU     "9"  ;LOW-TEIL MIT 9SEC
SEC_STELL_H   EQU     "5"  ;HIGH-TEIL MIT 5SEC   ALSO IN DER 59-ZIGSTEN SEC
  
;-----------------

;HIER STEHT DIE DOPPELPUNKT-BLINK AUS-ZEIT
   
;WENN 5SEC LANG KEIN PPS-SIGNAL ANLIEGT...
;WENN ALSO 5SEC LANG KEIN EXAKTER GPS-SIGNAL-EMPFANG VORLIEGT...
;HOEHRT DAS BLINKEN DES DOPPELPUNKTES AUF
   
;ZEIT UNTERHALB IN SEC EINTRAGEN
DOPP_AUS         EQU     D'5'   
   
;-----------------
         
;SCHRIFTDURCHLAUF-ANZAHL VON BERSCHRIFT AM ANFANG "GPS-UHREN-WECKER"
;WIEVIEL MAL TEXT_0
WIEVIEL_MAL_0     EQU     D'3'
     
;-----------------         
         
;SCHRIFTDURCHLAUF-ANZAHL VON ZEITZONE
;WIEVIEL MAL TEXT_1
WIEVIEL_MAL_1     EQU     D'1' 
     
;-----------------   
         
;SCHRIFTDURCHLAUF-ANZAHL VON STUNDEN-PIEPS-EIN/AUS
;WIEVIEL MAL TEXT_2 + TEXT_3
WIEVIEL_MAL_2     EQU     D'1'

;-----------------   
         
;SCHRIFTDURCHLAUF-ANZAHL VON WECK-TON WURDE VORZEITIG BEENDET
;WIEVIEL MAL TEXT_4
WIEVIEL_MAL_4     EQU     D'1'

;-----------------          
;SCHRIFTDURCHLAUF-ANZAHL VON "DIESE WECKZEIT IST JETZT EINGESTELLT"
;WIEVIEL MAL TEXT_5
WIEVIEL_MAL_5     EQU     D'1'

;----------------- 
         
;SCHRIFTDURCHLAUF-ANZAHL VON WECK-ALARM IST JETZT AKTIV ODER --->NICHT AKTIV TEXT_7
;WIEVIEL MAL TEXT_6+7
WIEVIEL_MAL_6     EQU     D'1'

;-----------------
;ZU LAUFTSCHRIFT     
;SCHRIFTDURCHLAUF-GESCHWINDIGKEIT / GILT FR ALLE TEXTE
;ZEIT BIS EIN NEUES ZEICHEN ERSCHEINT IN ZAHL MAL 10MSEC
;JETZT 280MSEC      
LAUF_ZEIT         EQU     D'28' 
     
;-----------------        
;STELL-GESCHWINDIGKEIT BEIM EINSTELLEN DER WECK-ALARM-ZEIT
;ALSO BEI TASTER GEDRCKT GEHALTEN         
;GROSSER WERT LANGSAMER
;KLEINER WERT SCHNELLER
STELL_GESCHWINDIGKEIT  EQU   D'12'
  
;NACH WIEVIEL ZAHLEN/ZEICHEN SICH DIE STELL-GESCHWINDIGKEIT DER WECKZEIT UM DAS 10 FACHE ERHOEHT
;JETZT SIND 20 ZEICHEN EINGESTELLT
NACH_ZEICHEN    EQU D'20'  

;DIE ZEITZONEN STELLGESCHWINDIGKEIT HAT EINEN FESTEN GESCHWINDIGKEITS-WERT
    
;-----------------
;NACH WELCHER ZEIT DIE EINSTELLUNGEN GESPEICHERT WERDEN --ALSO BEI WECK-ALARM UND ZEITZONE
;ALSO WIE LANGE MAN WARTEN MUSS / OHNE EINE TASTE ZU BETAETIGEN / BIS GESPEICHERT WIRD UND DIE UHRZEIT ERNEUT ERSCHEINT
;BERECHNUNG    0,5SEC * X = 
;JETZT  7,5SEC : 0,5SEC = 15    
WARTE_SPEICHERN     EQU D'15' 
  
;-----------------         
;ZEIT FR PIEPS ZUR VOLLEN STUNDE IN DER 00SEC  1SEC LANG
PIEP_AB_HIER   EQU H'08'    ;ALSO JETZT HIER AB 8UHR    // KLEINSTE UHRZEIT IST H'00' / ALSO NULL UHR
PIEP_BIS_HIER  EQU H'22'    ;ALSO JETZT HIER BIS 22UHR  // GRSSTE UHRZEIT IST H'23'  / ALSO 23UHR
;ALSO
;MIT H'00' BIS H'23' PIEPST ES JEDE STUNDE AUCH IN DER NACHT !!!!!!!! 
              
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!       
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!       
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  
   
;------------ MACROS ---------------------------------------------------------

PUSH    MACRO
        MOVWF   W_STACK
        MOVF    STATUS, W
        MOVWF   S_STACK
        ENDM
;----------------------------------------------------------------------------

POP     MACRO
        MOVF    S_STACK, W
        MOVWF   STATUS
        SWAPF   W_STACK, F
        SWAPF   W_STACK, W
        ENDM

;------------------------- MACROS -----------------------------------------

BANK0           MACRO                   ;MACRO TO SELECT DATA RAM BANK 0
                BCF     STATUS,RP0
                BCF     STATUS,RP1
                ENDM

BANK1           MACRO                   ;MACRO TO SELECT DATA RAM BANK 1
                BSF     STATUS,RP0
                BCF     STATUS,RP1
                ENDM

BANK2           MACRO                   ;MACRO TO SELECT DATA RAM BANK 2
                BCF     STATUS,RP0
                BSF     STATUS,RP1
                ENDM

BANK3           MACRO                   ;MACRO TO SELECT DATA RAM BANK 3
                BSF     STATUS,RP0
                BSF     STATUS,RP1
                ENDM


;----------------------------------------------------------------------------
;-----------------------------------------------------------------------------

;SPEICHERANFANG BZW. BEGINN

                ORG 0X0000
                GOTO    MAIN               ; SPRUNG ZUM HAUPTPROGRAMM
                ORG 0X0004
                GOTO    INTERRUPT ; RETFIE

                ORG 0X0010

;*****************************************************************************
;*                            INTERRUPT-PROGRAMM                             *
;*****************************************************************************               
INTERRUPT
        
        PUSH
      
        BTFSS   PIR1, TMR1IF        ; OVERFLOW IST 1 BEI TIMER1
        GOTO    INT_RB0

        CALL    INI_TIM        
            
        BTFSS   X2, BIT7
        GOTO    INT_TIM3
                               
            MOVLW   H'82'         
            CALL    BEFEHL
            MOVLW   ":"            
            CALL    DATEN
            
            MOVLW   H'85'         
            CALL    BEFEHL
            MOVLW   "."            
            CALL    DATEN
            
        MOVLW   D'1'
        CALL    ZAEHL
        
        CALL    ANZEIGE
        BCF     DENK, BIT0
        CALL    PIEPS
        CALL    WECK_SIGNAL
        BTFSC   DENK, BIT0
        BSF     PORTA, BIT1 ;SUMMER EIN
                  
        
            BTFSS   BLINK, BIT7
            GOTO    INT_TIM1
                        
            DECFSZ  MIT_PPS, F  ;NACH 10SEC OHNE PPS-SIGNAL
            GOTO    INT_TIM1
            MOVLW   D'1'
            MOVWF   MIT_PPS
            BCF     BLINK, BIT7 ;DOPPELPUNKT BLINKEN AUS MACHEN
            BSF     SYSTEM, BIT0 ;SOFORT STELLEN / WENN WIEDER RB0-INTERRUPT DA
            BCF     SYSTEM, BIT1    ;ERST WENN GPS-ZEIT NEU AUSGELESEN ANZEIGEN
            
INT_TIM1    BCF     X2, BIT7

                    BSF     INTCON, GIE         ;INTERRUPT WIEDER ZULASSEN
                    BSF     RCSTA, SPEN	        ;ENABLE SERIAL PORT        
 
            POP
            RETFIE
 
        
        
        
INT_TIM3    BTFSS   BLINK, BIT7
            GOTO    INT_TIM2
        
            MOVLW   H'82'         
            CALL    BEFEHL
            MOVLW   " "            
            CALL    DATEN
  
            BTFSS   KOMA, BIT7  ;KOMMA AUS MACHEN NUR EINMAL . DANN ANZEIGEN 
            GOTO    INT_TIM2
            MOVLW   H'85'         
            CALL    BEFEHL
            MOVLW   "."            
            CALL    DATEN
            BCF     KOMA, BIT7  ;GPS-ZEIT-BERNAHME DURCH KOMMA AUS
         
INT_TIM2    BSF     X2, BIT7

            
                    BSF     INTCON, GIE         ;INTERRUPT WIEDER ZULASSEN
                    BSF     RCSTA, SPEN	        ;ENABLE SERIAL PORT        
            
            POP
            RETFIE 
        


        
      
INT_RB0          
        MOVLW   DOPP_AUS         ;HIER 10 SEC EINGESTELLT / NACH 10SEC OHNE PPS-SIGNAL KEIN DOPPELPUNKT-BLINK / SIEHE OBEN BEI EINSTELLUNGEN
        MOVWF   MIT_PPS
        

;SOFORT BEI HIGH BIT0 GPS-ZEIT STELLEN        
        BTFSS   SYSTEM, BIT0
        GOTO    INT_RB4
        
        BTFSS   SYSTEM, BIT1
        GOTO    INT_RB3
        
        MOVF    SEC_L, W            ;ZEITUEBERNAHME  0X30
        ANDLW   0XF0
        SUBLW   0X30
        BTFSS   STATUS, Z
        GOTO    INT_RB3
        
        MOVF    SEC_H, W
        ANDLW   0XF0
        SUBLW   0X30
        BTFSS   STATUS, Z
        GOTO    INT_RB3
        
        ;BCF     SYSTEM, BIT1
        BCF     SYSTEM, BIT0    ;SOFORT ZEIT BERNEHMEN WIEDER RCKSETZEN
        GOTO    INT_SOFORT
        
INT_RB4 MOVF    SEC_H, W
        SUBLW   SEC_STELL_H       ;BEI ZEIT-UEBERNAHME D'59' GENAUER 0X35 // 
        BTFSS   STATUS, Z        
        GOTO    INT_RB3
    
        MOVF    SEC_L, W
        SUBLW   SEC_STELL_L       ;BEI ZEIT-UEBERNAHME D'59' GENAUER 0X39 // 
        BTFSS   STATUS, Z        
        GOTO    INT_RB3
      
INT_SOFORT
        CALL    INI_TIM   ;SYNCRON START MIT : BEGINNEND
        BCF     X2, BIT7
               
        MOVLW   H'82'         
        CALL    BEFEHL
        MOVLW   ":"            
        CALL    DATEN

        MOVF    H_H, W
        MOVWF   QH_H
         
        MOVF    H_L, W
        MOVWF   QH_L       
        
        MOVF    MIN_H, W
        MOVWF   QMIN_H
                
        MOVF    MIN_L, W
        MOVWF   QMIN_L
                
        MOVF    SEC_H, W
        MOVWF   QSEC_H
                
        MOVF    SEC_L, W
        MOVWF   QSEC_L
        
                
        MOVLW   KORREKTUR
        CALL    ZAEHL   ;JETZT HIER +1SEC KORREKTUR / SIEHE OBEN BEI EQU...
        
        ;MOVLW   D'15'
        ;MOVWF   ZAE1
        MOVLW   H'08'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
        MOVWF   PCLATH 
        CALL    H_BERECH
        MOVWF   MK ;ZAE1
        MOVLW   H'00'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300        
        MOVWF   PCLATH
        CALL    ZONE_H     ;KORREKTUR UTC/MEZ/MESZ / FUER H / SIEHE OBEN BEI EQU...
        
        ;MOVLW   D'15'
        ;MOVWF   ZAE1
        MOVLW   H'08'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
        MOVWF   PCLATH        
        CALL    MIN_BERECH
        MOVWF   MK ;ZAE1
        MOVLW   H'00'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300        
        MOVWF   PCLATH
        CALL    ZONE_MIN   ;KORREKTUR UTC/MEZ/MESZ / FUER MIN / SIEHE OBEN BEI EQU...
        
        CALL    ANZEIGE
        BCF     DENK, BIT0
        CALL    PIEPS
        CALL    WECK_SIGNAL
        BTFSC   DENK, BIT0
        BSF     PORTA, BIT1 ;SUMMER EIN
                
        BSF     BLINK, BIT7  ;BLINKEN ZULASSEN
        
            BSF     KOMA, BIT7  ;GPS-ZEIT BERNOMMEN DURCH KOMMA AUF BLITZEN /   
            MOVLW   H'85'         
            CALL    BEFEHL
            MOVLW   ","            
            CALL    DATEN
        
;VERGLEICH 0X30  BEI SEC_L UND SEC_H SOLL NEUE ZEIT VORHER GELESEN WORDEN SEIN
;DESHALB HIER UNSINN REIN MIT NICHT 0X30
;SONST WIRD LETZTER AUSGELESENE ZEIT ALS NICHT AKTUELL GENOMMEN            
            ;MOVLW   0XFF
            ;MOVWF   SEC_L
            BCF     SYSTEM, BIT1 ;DATEN MSSEN NEU GELESEN WERDEN
            
        BCF     INTCON, RBIF        ;INTERRUPT-FLAG WIRD ERST BEI INTERRUPT GESETZT / JETZT LSCHEN
        BCF     INTCON, INTF        ;INTERRUPT-FLAG WIRD ERST BEI INTERRUPT GESETZT / JETZT LSCHEN
     
                    BSF     INTCON, GIE         ;INTERRUPT WIEDER ZULASSEN
                    BSF     RCSTA, SPEN	        ;ENABLE SERIAL PORT        
                
        POP
        RETFIE
              
 
INT_RB3     BCF     INTCON, RBIF        ;INTERRUPT-FLAG WIRD ERST BEI INTERRUPT GESETZT / JETZT LSCHEN
            BCF     INTCON, INTF        ;INTERRUPT-FLAG WIRD ERST BEI INTERRUPT GESETZT / JETZT LSCHEN
    
                    BSF     INTCON, GIE         ;INTERRUPT WIEDER ZULASSEN
                    BSF     RCSTA, SPEN	        ;ENABLE SERIAL PORT        
  
            POP
            RETFIE
              
                
                
;*****************************************************************************
;*                            HAUPTPROGRAMM                                  *
;*****************************************************************************
;PORT-INITIALISIERUNG
MAIN            CLRF    PORTA                           
                CLRF    PORTB

                BANK1
                MOVLW   B'00001000'             ;ALS QUARZ SIEHE TAKTFREQUENZ OBEN...
                MOVWF   OSCCON

                MOVLW   0X07                    ;COMPARATORS ALLE AUS VOM PORT A
                MOVWF   CMCON
;AD-INIT
                MOVLW   B'00000000'             ;ALLES IO-PORTS
                MOVWF   ANSEL
                
                MOVLW   B'11111101'             ;INIT INPUT/OUTPUT AM PORTA / BEI 1 EINGANG  BEI 0 AUSGANG / RA1 AUSGANG(0) FUER PIEPS SONST ALLES EINGAENGE
                MOVWF   TRISA
                MOVLW   B'00000101'             ;INIT I/O AM PORTB  / BEI 1 EINGANG  BEI 0 AUSGANG / RB0 EINGANG(1) INTERRUPT FR PPS / (RB2-RXD) EINGANG(1) 
                MOVWF   TRISB

;INIT TIMER 0 FUER ZUM BEISPIEL 1MSEC+10MSEC
                MOVLW   B'10000101'             ;BIT0-2 101=PRESCALER64, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                MOVWF   OPTION_REG
                BCF     OPTION_REG, INTEDG  ; -STEIGENDE- FLANKE ZULASSEN BSF / ALSO VON NULL AUF +5VOLT
                                            ; FALLENDE FLANKE IST RICHTG MIT BCF !!!!!!!!!!!!!!!
                
;RS232-SERIALSETUP-COM-PORT
	MOVLW	BAUD_CONSTANT		;SET BAUD RATE 9600BAUD FOR 3,6864MHZ CLOCK , ERROR 0%
	MOVWF	SPBRG
	BCF	TXSTA, BRGH		;BAUD RATE LOW SPEED OPTION
        
	      ;BSF	TXSTA, TXEN		;ENABLE TRANSMISSION NUR BEI SENDEN
	BCF	TXSTA, SYNC		;MUSSNOCH REIN LAUT DATENBLATT-BESCHREIBUNG
	      ;BCF	TXSTA, TX9D		;KEINE 9BIT UEBERTRAGUNG NUR BEI SENDEN

	BANK0				
	BSF	RCSTA, CREN		;ENABLE RECEPTION // UNUNTERBROCHENER EMPFANG
 	BCF	RCSTA, RX9D		;KEINE 9BIT UEBERTRAGUNG
 
;NUR FUER RB0 INTERRUPT ZULASSEN
        
                BSF     INTCON, PEIE        ;INTERUPT ZULASSEN PEREPHERIE / 

                BSF     INTCON, INTE        ;INTERRUPT EXTERNAL VON RB0 ZULASSEN

                BCF     INTCON, RBIE        ;INTERRUPT FR EXTERNEN PIN NICHT ZULASSEN MIT CHANGE VON RB0 AUF GPX-EINGANG!!!

                BCF     INTCON, RBIF        ;INTERRUPT-FLAG WIRD ERST BEI INTERRUPT GESETZT / JETZT LSCHEN
                BCF     INTCON, INTF        ;INTERRUPT-FLAG WIRD ERST BEI INTERRUPT GESETZT / JETZT LSCHEN
                      ;BSF     INTCON, GIE         ;ALLGEMEINES INTERRUPT ENABLE ---->ERST SPTER !!!!!!!!!!!!!!!!!
       
        
        
;INIT-ENDE  
;-----------------------------------------------------------------------------

                CLRF    PORTA
                CLRF    PORTB
                  
                MOVLW   D'2'
                CALL    ZS10MSEC
      
                
;-----------------------------------------------------------------------------
  
                MOVLW   0X30 ;EEPROM ADRESSE ALARM EIN AUS
                MOVWF   ADR
                CALL    E_READ
                
                SUBLW   0XFF
                BTFSS   STATUS, Z
                GOTO    AUSLESEN
                
;GRUNDEINSTELLUNGEN NACH DEM NEU-BRENNEN EINSTELLEN FR ALARM
                MOVLW   0X30 ;EEPROM ADRESSE ALARM EIN AUS
                MOVWF   ADR
                CLRF    ALARM ;ALARM JETZT AUS
                MOVF    ALARM, W
                CALL    E_WRITE
 
;GRUNDEINSTELLUNG NACH DEM NEU BRENNEN FR ZEIT-ZONE
                MOVLW   0X20 ;EEPROM ADRESSE ZEITZONE
                MOVWF   ADR
                               
                MOVLW   D'13' ;ZEITZONE UTC
                MOVWF   ZAE1
                CALL    E_WRITE

                
;GRUNDEINSTELLUNG NACH DEM NEU BRENNEN FR WECKZEIT
                MOVLW   0X10 ;EEPROM ADRESSE 
                MOVWF   ADR
                MOVLW   0X31 ;ZEIT
                MOVWF   WH_H
                CALL    E_WRITE
                
                MOVLW   0X11 ;EEPROM ADRESSE 
                MOVWF   ADR
                MOVLW   0X32 ;ZEIT
                MOVWF   WH_L
                CALL    E_WRITE                 
               
                MOVLW   0X12 ;EEPROM ADRESSE 
                MOVWF   ADR
                MOVLW   0X30 ;ZEIT
                MOVWF   WMIN_H
                CALL    E_WRITE                   
                  
                MOVLW   0X13 ;EEPROM ADRESSE 
                MOVWF   ADR
                MOVLW   0X35 ;ZEIT
                MOVWF   WMIN_L
                CALL    E_WRITE                   
 
;GRUNDEINSTELLUNG NACH DEM NEU BRENNEN FR WECKER-EIN/AUS
                MOVLW   0X40 ;EEPROM ADRESSE ALARM EIN AUS
                MOVWF   ADR
                CLRF    WECK ;WECKER JETZT AUS
                MOVF    WECK, W
                CALL    E_WRITE               
                
                
                GOTO    DOGM_LCD
                
;ALTE EINGESTELLTEN DATEN AUS EEPROM AUSLESEN / WAREN ALSO SCHON MAL GESPEICHERT
AUSLESEN
                MOVLW   0X30 ;EEPROM ADRESSE ALARM EIN AUS
                MOVWF   ADR
                CALL    E_READ
                MOVWF   ALARM
                
                MOVLW   0X20 ;EEPROM ADRESSE ZEITZONE
                MOVWF   ADR
                CALL    E_READ
                MOVWF   ZAE1
                
                MOVLW   0X40 ;EEPROM ADRESSE ALARM EIN AUS
                MOVWF   ADR
                CALL    E_READ
                MOVWF   WECK
                                
                MOVLW   0X10 ;EEPROM ADRESSE 
                MOVWF   ADR
                CALL    E_READ
                MOVWF   WH_H
                                           
                MOVLW   0X11 ;EEPROM ADRESSE 
                MOVWF   ADR
                CALL    E_READ
                MOVWF   WH_L
                                                
                MOVLW   0X12 ;EEPROM ADRESSE 
                MOVWF   ADR
                CALL    E_READ
                MOVWF   WMIN_H
                                               
                MOVLW   0X13 ;EEPROM ADRESSE 
                MOVWF   ADR
                CALL    E_READ
                MOVWF   WMIN_L            
                
;-----------------------------------------------------------------------------                
;INITIALISIERUNG DOGM-LCD
DOGM_LCD                
            MOVLW   D'2'
            MOVWF   HELP
           
INIT_LCD
            MOVLW   H'21'                   ;FUNCTION SET  4-BIT-LAENGE, 1-ZEILIG, 5X7FONT
            CALL    BEFEHL
 
            MOVLW   H'1C'                   ;BIAS SET
            CALL    BEFEHL
 
            MOVLW   H'51'                   ;BOOSTER OFF CONTRAST
            CALL    BEFEHL
 
            MOVLW   H'6A'                   ;SET VOLTAGE
            CALL    BEFEHL
 
            MOVLW   H'74'                   ;CONTRAST SET
            CALL    BEFEHL

            MOVLW   H'20'                   ;FUNCTION SET  4-BIT-LAENGE, 1-ZEILIG, 5X7FONT
            CALL    BEFEHL
 
            MOVLW   H'0C'                   ;DISPLAY ON/OFF   DISPLAY ON, CURSOR OFF, BLINK OFF
            CALL    BEFEHL

            DECFSZ  HELP, F
            GOTO    INIT_LCD
 
;----------- LCD-DOGM-AUSGEBEN ------------------------          
ANF         
            BSF     AUSWAHL_TXT, BIT0  ;TEXT_0 AUSWHLEN
            MOVLW   WIEVIEL_MAL_0+1
            MOVWF   MAL
            CALL    LAUFSCHRIFT
            
            BCF     AUSWAHL_TXT, BIT0 
            BSF     SYSTEM, BIT0    ;SOFORT GPS-ZEIT DARSTELLEN    
                
            MOVLW   H'82'         
            CALL    BEFEHL
            MOVLW   ":"            
            CALL    DATEN

            MOVLW   H'85'            
            CALL    BEFEHL
            MOVLW   "."
            CALL    DATEN
            
;----------- GRUNDEINSTELLUNG FR NORMALE-QUARZ-UHR ------------------------------
;----------- UND ANZEIGE ---------------------------------------------------------

            MOVLW   0X30

            MOVWF   QH_H
            MOVWF   QH_L
            MOVWF   QMIN_H
            MOVWF   QMIN_L
            MOVWF   QSEC_H
            MOVWF   QSEC_L
             
            CALL    ANZEIGE
        
;----------- INIT 0,5 SEC --------------------------------------------------------
;----------- ES WIRD TIMER1 GENOMMEN MIT INTERRUPT -------------------------------
;----------- ZEITBASIS DER NORMALEN QUARZ-UHR ------------------------------------

        BSF     INTCON, GIE         ; GLOBALER INTERRUPT ENABLE + PERIPHERAL INTERRUPT ////////SCHON OBEN
        
        CALL    INI_TIM             ; ERST IM INTERRUPT MIT RB0 STARTEN       
        BANK1
        BSF     PIE1, TMR1IE        ; TIMER1 OVERFLOW-INTERRUPT ENABLE
        BANK0

        
        BCF     X2, BIT7
        BCF     BLINK, BIT7         ;BLINKEN AUS
        BCF     KOMA, BIT7          ;BERNAHME OK KOMMA AUS
         
;---------------------------------------------------------------------------------
            BCF     SYSTEM, BIT1    ;ERST WENN GPS-ZEIT NEU AUSGELESEN ANZEIGEN  
            BSF     SYSTEM, BIT0    ;SOFORT ANZEIGEN
            BSF     RCSTA, SPEN     ;ENABLE SERIAL PORT 
     
ANF_RX0
            BCF     RCSTA, CREN
            BSF     RCSTA, CREN
   
ANF_RX           
;TASTER GEDRCKT ?
            BTFSS   PORTA, BIT2
            CALL    TAST23_RX         
            BTFSS   PORTA, BIT3
            CALL    TAST23_RX   
            BTFSS   PORTA, BIT0 
            CALL    TAST4_RX    ;NACH 2SEC H-PIEPS AUS/EIN /// NACH KURZEM DRUCK WECKER VORZEITIG AUS           
            BTFSS   PORTA, BIT4
            CALL    TAST5_RX    ;NACH 2SEC WECKZEIT STELLBAR /// NACH KURZEM DRUCK WECKER EIN/AUS
 
                    BSF     INTCON, GIE         ;INTERRUPT WIEDER ZULASSEN
                    BSF     RCSTA, SPEN	        ;ENABLE SERIAL PORT        
            
        BTFSS	PIR1, RCIF          ;WURDEN DATEN EMPFANGEN //PUFFER 2-3BYTES
        GOTO	ANF_RX			
       
	MOVF	RCREG, W		;IN W DIE DATEN
         
            BCF     RCSTA, CREN
            BSF     RCSTA, CREN

        SUBLW   CODE1       ;$=0X24 - W =>ERGEBNIS IN W 
        BTFSS   STATUS, Z  ;ZERO-ABFRAGE BEI HIGH(1) IST ES GLEICH / BEI LOW (0) UNGLEICH
        GOTO    ANF_RX
        
        MOVLW   D'5'
        MOVWF   ZAE
 
ANF0_RX
        BTFSS	PIR1, RCIF          ;WURDEN DATEN EMPFANGEN //PUFFER 2-3BYTES
        GOTO	ANF0_RX			
        
	MOVF	RCREG, W		;IN W DIE DATEN

            BCF     RCSTA, CREN
            BSF     RCSTA, CREN
 
        DECFSZ  ZAE, F
        GOTO    ANF0_RX
        
        SUBLW   CODE2        ;C - W =>ERGEBNIS IN W 
        BTFSS   STATUS, Z  ;ZERO-ABFRAGE BEI HIGH(1) IST ES GLEICH / BEI LOW (0) UNGLEICH
        GOTO    ANF_RX0
     
ANF1_RX
        BTFSS	PIR1, RCIF          ;WURDEN DATEN EMPFANGEN //PUFFER 2-3BYTES
        GOTO	ANF1_RX			
;DAS KOMMA AUSLESEN                
	MOVF	RCREG, W		;IN W DIE DATEN

            BCF     RCSTA, CREN
            BSF     RCSTA, CREN

ANF2_RX
        BTFSS	PIR1, RCIF          ;WURDEN DATEN EMPFANGEN //PUFFER 2-3BYTES
        GOTO	ANF2_RX			
;H_H AUSLESEN                
	MOVF	RCREG, W		;IN W DIE DATEN
        MOVWF   H_H
            BCF     RCSTA, CREN
            BSF     RCSTA, CREN

ANF3_RX
        BTFSS	PIR1, RCIF          ;WURDEN DATEN EMPFANGEN //PUFFER 2-3BYTES
        GOTO	ANF3_RX			
;AUSLESEN                
	MOVF	RCREG, W		;IN W DIE DATEN
        MOVWF   H_L
            BCF     RCSTA, CREN
            BSF     RCSTA, CREN

ANF4_RX
        BTFSS	PIR1, RCIF          ;WURDEN DATEN EMPFANGEN //PUFFER 2-3BYTES
        GOTO	ANF4_RX			
;AUSLESEN                
	MOVF	RCREG, W		;IN W DIE DATEN
        MOVWF   MIN_H
            BCF     RCSTA, CREN
            BSF     RCSTA, CREN
 
ANF5_RX
        BTFSS	PIR1, RCIF          ;WURDEN DATEN EMPFANGEN //PUFFER 2-3BYTES
        GOTO	ANF5_RX			
;AUSLESEN                
	MOVF	RCREG, W		;IN W DIE DATEN
        MOVWF   MIN_L
            BCF     RCSTA, CREN
            BSF     RCSTA, CREN

ANF6_RX
        BTFSS	PIR1, RCIF          ;WURDEN DATEN EMPFANGEN //PUFFER 2-3BYTES
        GOTO	ANF6_RX			
;AUSLESEN                
	MOVF	RCREG, W		;IN W DIE DATEN
        MOVWF   SEC_H
            BCF     RCSTA, CREN
            BSF     RCSTA, CREN

ANF7_RX
        BTFSS	PIR1, RCIF          ;WURDEN DATEN EMPFANGEN //PUFFER 2-3BYTES
        GOTO	ANF7_RX			
;AUSLESEN                
	MOVF	RCREG, W		;IN W DIE DATEN
        MOVWF   SEC_L
            BCF     RCSTA, CREN
            BSF     RCSTA, CREN

            
            
    
        ;BTFSC   SYSTEM, BIT1        ;ERST 1X NEU AUSGELESEN WURDE / SONST STEHT ALTE ZEIT DRIN VOR UNTERBRECHUNG
        ;BSF     INTCON, GIE         ;GLOBALER INTERRUPT ENABLE + PERIPHERAL INTERRUPT  
        
        ;BCF     SYSTEM, BIT1
        BSF     SYSTEM, BIT1 ;NEU
        GOTO    ANF_RX0
 
;*****************************************************************************
;*                              LAUFSCHRIFT ZEIT-ZONE                        *
;***************************************************************************** 
TAST23_RX
         BCF     INTCON, GIE     ;INTERRUPT SPERREN // MUSS SO GEMACHT WERDEN!!! // NICHT NUR --> BCF  INTCON, GIE
         BTFSC   INTCON, GIE
         GOTO    TAST23_RX
        
            CLRF    AUSWAHL_TXT
            BCF     MERK1, BIT0        ;REPEAT AUS BIT0
    
            
            BSF     AUSWAHL_TXT, BIT1  ;TEXT_1 AUSWHLEN
            MOVLW   WIEVIEL_MAL_1+1
            MOVWF   MAL
            CALL    LAUFSCHRIFT
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;            
TA00        CALL    ZONE_ANZEIGE
            
TA03        CALL    ZS5SEC_TASTER 
            
            BTFSS   PORTA, BIT2 ;HOCH STELLEN
            GOTO    TA01
            BTFSS   PORTA, BIT3 ;RUNTER STELLEN
            GOTO    TA02

            BTFSC   SYSTEM, BIT2    ;ENDE 5SEC ZS
            GOTO    TA_ENDE
            GOTO    TA03

;---------------------------------------------------------------------------------------
;GEDRCKT AUF-TASTER
TA01 ;EITF  
                    MOVLW   D'20'           ;ENTPRELLUNG 20MSEC, 
                    MOVWF   MK
FENT01              BTFSC   PORTA, BIT2
                    GOTO    TA03
                    MOVLW   D'1'
                    CALL    ZS1MSEC         ;1MSEC
                    DECFSZ  MK, F
                    GOTO    FENT01

;REPEAT ALLER 360MSEC
                    MOVLW   D'18'          ;ENTPRELLUNG 360MSEC, 
                    MOVWF   MK
                    
FENT02              BTFSC   PORTA, BIT2
                    GOTO    FLOSL
                    MOVLW   D'20'
                    CALL    ZS1MSEC        ;1MSEC
                    DECFSZ  MK, F
                    GOTO    FENT02

            INCF    ZAE1, F
            MOVF    ZAE1, W
            SUBLW   D'35'
            BTFSS   STATUS, Z
            GOTO    TA00
            
            MOVLW   D'34'
            MOVWF   ZAE1
 
              
FRPAB01             BSF     MERK1, BIT0     ;REPEAT MERKER
                    GOTO    TA00

;LOSLASSEN AUF-TASTER                                                      
FLOSL               MOVLW   D'20'           ;ENTPRELLUNG 20MSEC, 
                    MOVWF   MK
FENT03              BTFSS   PORTA, BIT2
                    GOTO    FLOSL
                    MOVLW   D'1'
                    CALL    ZS1MSEC         ;1MSEC
                    DECFSZ  MK, F
                    GOTO    FENT03
            
                    BTFSS   MERK1, BIT0     ;REPEAT MERKER
                    GOTO    FFERT
                    CLRF    MERK1
                    GOTO    TA00
                    
FFERT       INCF    ZAE1, F
            MOVF    ZAE1, W
            SUBLW   D'35'
            BTFSS   STATUS, Z
            GOTO    TA00
            
            MOVLW   D'34'
            MOVWF   ZAE1
            GOTO    TA00

         
            

;---------------------------------------------------------------------------------------
;GEDRCKT RUNTER-AB-TASTER
TA02 
                    MOVLW   D'20'           ;ENTPRELLUNG 20MSEC, 
                    MOVWF   MK
ENT01               BTFSC   PORTA, BIT3
                    GOTO    TA03
                    MOVLW   D'1'
                    CALL    ZS1MSEC         ;1MSEC
                    DECFSZ  MK, F
                    GOTO    ENT01

;REPEAT ALLER 360MSEC
RPAB                MOVLW   D'18'          ;ENTPRELLUNG 360MSEC, 
                    MOVWF   MK
                    
ENT02               BTFSC   PORTA, BIT3
                    GOTO    LOSL
                    MOVLW   D'20'
                    CALL    ZS1MSEC        ;1MSEC
                    DECFSZ  MK, F
                    GOTO    ENT02

            DECF    ZAE1, F
            MOVF    ZAE1, W
            SUBLW   0XFF
            BTFSS   STATUS, Z
            GOTO    RPAB01
            
            MOVLW   D'0'
            MOVWF   ZAE1
              
RPAB01              BSF     MERK1, BIT0     ;REPEAT MERKER
                    GOTO    TA00

;LOSLASSEN AB-TASTER                
                                       
LOSL                MOVLW   D'20'           ;ENTPRELLUNG 20MSEC, 
                    MOVWF   MK
ENT03               BTFSS   PORTA, BIT3
                    GOTO    LOSL
                    MOVLW   D'1'
                    CALL    ZS1MSEC         ;1MSEC
                    DECFSZ  MK, F
                    GOTO    ENT03
            
                    BTFSS   MERK1, BIT0     ;REPEAT MERKER
                    GOTO    FERT
                    CLRF    MERK1
                    GOTO    TA00
                    
FERT        DECF    ZAE1, F
            MOVF    ZAE1, W
            SUBLW   0XFF
            BTFSS   STATUS, Z
            GOTO    TA00
            
            MOVLW   D'0'
            MOVWF   ZAE1
            GOTO    TA00

         
            
            
            

        
TA_ENDE            
            BSF     RCSTA, SPEN ;ENABLE SERIAL PORT             
            BCF     AUSWAHL_TXT, BIT1 
            BSF     SYSTEM, BIT0    ;SOFORT GPS-ZEIT DARSTELLEN    
            BCF     SYSTEM, BIT1    ;ERST WENN GPS-ZEIT NEU AUSGELESEN ANZEIGEN

        MOVLW   0X20
        MOVWF   ADR
        MOVF    ZAE1, W
        CALL    E_WRITE 

            RETURN    

;*****************************************************************************
;*                              LAUFSCHRIFT PIEPSER EIN AUS + WECK-ALARM AUS *
;*****************************************************************************             
TAST4_RX
         BCF     INTCON, GIE     ;INTERRUPT SPERREN // MUSS SO GEMACHT WERDEN!!! // NICHT NUR --> BCF  INTCON, GIE
         BTFSC   INTCON, GIE
         GOTO    TAST4_RX
     
            MOVLW   D'3'        ;STARRE ENTPRELLUNG
            CALL    ZS10MSEC
            BTFSC   PORTA, BIT0
            RETURN
            
            MOVLW   H'01'                   ;CLEAR DISPLAY
            CALL    BEFEHL
;ZEITSCHLEIFE VON 2MSEC, MUSS SEIN WEGEN LSCHEN
            MOVLW   D'4'
            CALL    ZS1MSEC    

            
            CLRF    AUSWAHL_TXT
            MOVLW   D'20'
            MOVWF   HELP2
            
TAST42      MOVLW   D'10'
            CALL    ZS10MSEC
            BTFSC   PORTA, BIT0
            GOTO    TAST41
            
            DECFSZ  HELP2, F
            GOTO    TAST42

            
;NACH 2SEC GEDRCKT            
            BTFSS   ALARM ,BIT0
            GOTO    TAST44

            BSF     AUSWAHL_TXT, BIT3  ;TEXT_3 AUSWHLEN
            MOVLW   WIEVIEL_MAL_2+1
            MOVWF   MAL
            CALL    LAUFSCHRIFT
            
            BSF     RCSTA, SPEN ;ENABLE SERIAL PORT             
            BCF     AUSWAHL_TXT, BIT3 
            BSF     SYSTEM, BIT0    ;SOFORT GPS-ZEIT DARSTELLEN
            BCF     SYSTEM, BIT1    ;ERST WENN GPS-ZEIT NEU AUSGELESEN ANZEIGEN 

            CLRF    ALARM    
            ;BCF     ALARM, BIT0

        MOVLW   0X30
        MOVWF   ADR
        MOVF    ALARM, W
        CALL    E_WRITE 
        
            RETURN

            
            
TAST44      BSF     AUSWAHL_TXT, BIT2  ;TEXT_2 AUSWHLEN
            MOVLW   WIEVIEL_MAL_2+1
            MOVWF   MAL
            CALL    LAUFSCHRIFT
            
            BSF     RCSTA, SPEN ;ENABLE SERIAL PORT             
            BCF     AUSWAHL_TXT, BIT2 
            BSF     SYSTEM, BIT0    ;SOFORT GPS-ZEIT DARSTELLEN 
            BCF     SYSTEM, BIT1    ;ERST WENN GPS-ZEIT NEU AUSGELESEN ANZEIGEN 

            CLRF    ALARM    
            BSF     ALARM, BIT0

        MOVLW   0X30
        MOVWF   ADR
        MOVF    ALARM, W
        CALL    E_WRITE 
 
            RETURN            
 
;VOR 2SEC LOSGELASSEN            
TAST41            
;WECK-TON AUSSCHALTEN
            BCF     PORTA, BIT1     ;PIEPSER AUS
            BSF     AUS, BIT0  ;BLEIBT AUS 
            
;ERST BEIM LOSLASSEN GPS-ZEIT AKTIV /// ALSO ENTPRELLEN 
            ;MOVLW   D'4'
            ;CALL    ZS10MSEC
            ;BTFSS   PORTA, BIT5
            ;GOTO    TAST41 
            
            BSF     AUSWAHL_TXT, BIT4  ;TEXT_4 AUSWHLEN
            MOVLW   WIEVIEL_MAL_4+1
            MOVWF   MAL
            CALL    LAUFSCHRIFT
            
            BSF     RCSTA, SPEN ;ENABLE SERIAL PORT             
            ;BCF     AUSWAHL_TXT, BIT4 
            BSF     SYSTEM, BIT0    ;SOFORT GPS-ZEIT DARSTELLEN
            BCF     SYSTEM, BIT1    ;ERST WENN GPS-ZEIT NEU AUSGELESEN ANZEIGEN 

            RETURN
 
;*****************************************************************************
;*                LAUFSCHRIFT WECK-ALARM EIN AUS + WECK-ZEIT STELLBAR MACHEN *
;*****************************************************************************             
TAST5_RX
         BCF     INTCON, GIE     ;INTERRUPT SPERREN // MUSS SO GEMACHT WERDEN!!! // NICHT NUR --> BCF  INTCON, GIE
         BTFSC   INTCON, GIE
         GOTO    TAST5_RX
        
            MOVLW   D'3'        ;STARRE ENTPRELLUNG
            CALL    ZS10MSEC
            BTFSC   PORTA, BIT4
            RETURN
            
            MOVLW   H'01'                   ;CLEAR DISPLAY
            CALL    BEFEHL
;ZEITSCHLEIFE VON 2MSEC, MUSS SEIN WEGEN LSCHEN
            MOVLW   D'4'
            CALL    ZS1MSEC    

            
            CLRF    AUSWAHL_TXT
            MOVLW   D'20'
            MOVWF   HELP2
            
TAST52      MOVLW   D'10'
            CALL    ZS10MSEC
            BTFSC   PORTA, BIT4 
            GOTO    TAST51
            
            DECFSZ  HELP2, F
            GOTO    TAST52


;NACH 2SEC GEDRCKT                       
            BSF     AUSWAHL_TXT, BIT5  ;TEXT_5 AUSWHLEN
            MOVLW   WIEVIEL_MAL_5+1
            MOVWF   MAL
            CALL    LAUFSCHRIFT

            
;LEERSTELLEN IM DISPLAY LSCHEN            
                MOVLW   0X80
                CALL    BEFEHL
                MOVLW   " "
                CALL    DATEN
                MOVLW   0X81
                CALL    BEFEHL
                MOVLW   " "
                CALL    DATEN        
                MOVLW   0X84
                CALL    BEFEHL
                MOVLW   ":"
                CALL    DATEN
                MOVLW   0X87
                CALL    BEFEHL
                MOVLW   " "
                CALL    DATEN       
                  
                MOVLW   NACH_ZEICHEN
                MOVWF   SCHNELL
      
                
;STELLEN WECKZEIT REIN MACHEN            
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;            
WTA00       CALL    WECK_ANZEI
            
WTA03       CALL    ZS5SEC_TASTER 
            
            BTFSS   PORTA, BIT2 ;HOCH STELLEN
            GOTO    WTA01
            BTFSS   PORTA, BIT3 ;RUNTER STELLEN
            GOTO    WTA02

            BTFSC   SYSTEM, BIT2    ;ENDE 5SEC ZS
            GOTO    WTA_ENDE
            GOTO    WTA03


;---------------------------------------------------------------------------------------
;GEDRCKT AUF-TASTER
WTA01 
                    MOVLW   D'10'           ;ENTPRELLUNG 10MSEC, 
                    MOVWF   MK
WFENT01             BTFSC   PORTA, BIT2
                    GOTO    WTA03
                    MOVLW   D'1'
                    CALL    ZS1MSEC         ;1MSEC
                    DECFSZ  MK, F
                    GOTO    WFENT01

                    MOVLW   STELL_GESCHWINDIGKEIT          
                    MOVWF   MK
                    
                    DECFSZ  SCHNELL, F
                    GOTO    WFENT_01
                    
                    
WFENT_03            BTFSC   PORTA, BIT2
                    GOTO    WFLOSL

                    MOVLW   D'1'
                    CALL    ZS1MSEC        ;1MSEC
                    DECFSZ  MK, F
                    GOTO    WFENT_03
                    MOVLW   D'1'
                    MOVWF   SCHNELL
                    GOTO    WFENT_02
                    
WFENT_01            BTFSC   PORTA, BIT2
                    GOTO    WFLOSL
                    
                    MOVLW   D'10'
                    CALL    ZS1MSEC        ;1MSEC
                    DECFSZ  MK, F
                    GOTO    WFENT_01

;ERHHEN                    
WFENT_02            CALL    WECK_AUF ;AUFWRTS STELLEN
                    GOTO    WTA00

;LOSLASSEN AUF-TASTER                                                      
WFLOSL              MOVLW   D'10'           ;ENTPRELLUNG 10MSEC, 
                    MOVWF   MK
WFENT03             BTFSS   PORTA, BIT2
                    GOTO    WFLOSL
                    MOVLW   D'1'
                    CALL    ZS1MSEC         ;1MSEC
                    DECFSZ  MK, F
                    GOTO    WFENT03
                    
                    MOVLW   NACH_ZEICHEN 
                    MOVWF   SCHNELL

                    GOTO    WTA00

         
            

;---------------------------------------------------------------------------------------
;GEDRCKT RUNTER-AB-TASTER
WTA02 
                    MOVLW   D'10'           ;ENTPRELLUNG 10MSEC, 
                    MOVWF   MK
WENT01              BTFSC   PORTA, BIT3
                    GOTO    WTA03
                    MOVLW   D'1'
                    CALL    ZS1MSEC         ;1MSEC
                    DECFSZ  MK, F
                    GOTO    WENT01

                    MOVLW   STELL_GESCHWINDIGKEIT          
                    MOVWF   MK
                    
                    DECFSZ  SCHNELL, F
                    GOTO    WENT_01
                    
                    
WENT_03             BTFSC   PORTA, BIT3
                    GOTO    WLOSL

                    MOVLW   D'1'
                    CALL    ZS1MSEC        ;1MSEC
                    DECFSZ  MK, F
                    GOTO    WENT_03
                    MOVLW   D'1'
                    MOVWF   SCHNELL
                    GOTO    WENT_02
                    
WENT_01             BTFSC   PORTA, BIT3
                    GOTO    WLOSL
                    
                    MOVLW   D'10'
                    CALL    ZS1MSEC        ;1MSEC
                    DECFSZ  MK, F
                    GOTO    WENT_01

;ERNIEDRIGEN                 
WENT_02            CALL    WECK_AB ;ABWRTS STELLEN
                   GOTO    WTA00

;LOSLASSEN AUF-TASTER                                                      
WLOSL               MOVLW   D'10'           ;ENTPRELLUNG 10MSEC, 
                    MOVWF   MK
WENT03              BTFSS   PORTA, BIT3
                    GOTO    WFLOSL
                    MOVLW   D'1'
                    CALL    ZS1MSEC         ;1MSEC
                    DECFSZ  MK, F
                    GOTO    WENT03
                    
                    MOVLW   NACH_ZEICHEN 
                    MOVWF   SCHNELL

                    GOTO    WTA00
    
WTA_ENDE 
;ABSPEICHERN 
                MOVLW   0X10 ;EEPROM ADRESSE 
                MOVWF   ADR
                MOVF    WH_H, W
                CALL    E_WRITE
                
                MOVLW   0X11 ;EEPROM ADRESSE 
                MOVWF   ADR
                MOVF    WH_L, W
                CALL    E_WRITE                 
               
                MOVLW   0X12 ;EEPROM ADRESSE 
                MOVWF   ADR
                MOVF    WMIN_H, W
                CALL    E_WRITE                   
                  
                MOVLW   0X13 ;EEPROM ADRESSE 
                MOVWF   ADR
                MOVF    WMIN_L, W
                CALL    E_WRITE        
 
            BSF     RCSTA, SPEN ;ENABLE SERIAL PORT             
            BCF     AUSWAHL_TXT, BIT5 
            BSF     SYSTEM, BIT0    ;SOFORT GPS-ZEIT DARSTELLEN
            BCF     SYSTEM, BIT1    ;ERST WENN GPS-ZEIT NEU AUSGELESEN ANZEIGEN 
  
            RETURN            
            
 
            
            
TAST51              
;VOR 2SEC LOSGELASSEN            
            BTFSC   WECK ,BIT0
            GOTO    TAST55

            BSF     AUSWAHL_TXT, BIT6  ;TEXT_6 AUSWHLEN
            MOVLW   WIEVIEL_MAL_6+1
            MOVWF   MAL
            CALL    LAUFSCHRIFT
            
            BSF     RCSTA, SPEN ;ENABLE SERIAL PORT             
            BCF     AUSWAHL_TXT, BIT6 
            BSF     SYSTEM, BIT0    ;SOFORT GPS-ZEIT DARSTELLEN
            BCF     SYSTEM, BIT1    ;ERST WENN GPS-ZEIT NEU AUSGELESEN ANZEIGEN 

            ;CLRF    WECK    
            BSF     WECK, BIT0 ;WECK EIN

       
        MOVLW   0X40
        MOVWF   ADR
        MOVF    WECK, W
        CALL    E_WRITE 
        
            RETURN

            
            
TAST55      BSF     AUSWAHL_TXT, BIT7  ;TEXT_7 AUSWHLEN
            MOVLW   WIEVIEL_MAL_6+1
            MOVWF   MAL
            CALL    LAUFSCHRIFT
            
            BSF     RCSTA, SPEN ;ENABLE SERIAL PORT             
            BCF     AUSWAHL_TXT, BIT7 
            BSF     SYSTEM, BIT0    ;SOFORT GPS-ZEIT DARSTELLEN 
            BCF     SYSTEM, BIT1    ;ERST WENN GPS-ZEIT NEU AUSGELESEN ANZEIGEN 

            ;CLRF    WECK    
            BCF     WECK, BIT0
             
        MOVLW   0X40
        MOVWF   ADR
        MOVF    WECK, W
        CALL    E_WRITE 
 
            RETURN                     
 
;*****************************************************************************
;*                              IN EEPROM SCHREIBEN                          *
;*****************************************************************************
E_WRITE  ;BCF     INTCON, GIE     ;INTERRUPT SPERREN // MUSS SO GEMACHT WERDEN!!! // NICHT NUR --> BCF  INTCON, GIE
         ;BTFSC   INTCON, GIE
         ;GOTO    E_WRITE         
            
                BANK3
E_1             BTFSC   EECON1, WR
                GOTO    E_1
                
                BANK2
                MOVWF   EEDATA
                BANK0
                MOVF    ADR, W
                BANK2
                MOVWF   EEADR
            
                BANK3
                BCF     EECON1, EEPGD
                BSF     EECON1, WREN
                MOVLW   0X55
                MOVWF   EECON2
                MOVLW   0XAA
                MOVWF   EECON2
                BSF     EECON1, WR
                BCF     EECON1, WREN
                BANK0
                
         ;BSF     INTCON, GIE     ;INTERRUPT WIEDER ZULASSEN 
         
                RETURN
                
;*****************************************************************************
;*                              AUS EEPROM LESEN                             *
;*****************************************************************************
E_READ          MOVF    ADR, W
                BANK2
                MOVWF   EEADR
                
                BANK3
                BCF     EECON1, EEPGD
                BSF     EECON1, RD

                BANK2
                MOVF    EEDATA, W
                BANK0
                RETURN               
                
      
;*****************************************************************************
;*                              INIT-TIMER1                                  *
;*****************************************************************************
INI_TIM BCF     T1CON, TMR1ON       ;STOP TIMER1        
        BCF     PIR1, TMR1IF        ;OVERFLOW ZU 0
        MOVLW   0XFD                ;
        MOVWF   TMR1L               ;
                                    ;
        MOVLW   0X1E                ;
        MOVWF   TMR1H               ;

        MOVLW   0X31 ;
        MOVWF   T1CON              ;START TIMER 1
        RETURN
        
        
;*****************************************************************************
;*                              ZEIT HOCHZAEHLEN +1SEC +2SEC +3SEC...        *
;*****************************************************************************
ZAEHL
        MOVWF   HELP        
        SUBLW   D'0'
        BTFSC   STATUS, Z        
        RETURN
        
ZAEHL1        
        INCF    QSEC_L, F
        MOVF    QSEC_L, W
        SUBLW   0X3A
        BTFSS   STATUS, Z
        GOTO    QQQ
        
        MOVLW   0X30
        MOVWF   QSEC_L
        
        INCF    QSEC_H, F
        MOVF    QSEC_H, W
        SUBLW   0X36
        BTFSS   STATUS, Z
        GOTO    QQQ
     
        MOVLW   0X30
        MOVWF   QSEC_H
                
        INCF    QMIN_L, F
        MOVF    QMIN_L, W
        SUBLW   0X3A
        BTFSS   STATUS, Z
        GOTO    QQQ
      
        MOVLW   0X30
        MOVWF   QMIN_L
                
        INCF    QMIN_H, F
        MOVF    QMIN_H, W
        SUBLW   0X36
        BTFSS   STATUS, Z
        GOTO    QQQ
            
        MOVLW   0X30
        MOVWF   QMIN_H
     
        MOVF    QH_H, W
        SUBLW   0X32
        BTFSS   STATUS, Z
        GOTO    QHH1
        
        INCF    QH_L, F
        MOVF    QH_L, W
        SUBLW   0X34
        BTFSS   STATUS, Z
        GOTO    QQQ
         
        MOVLW   0X30
        MOVWF   QH_L
        MOVWF   QH_H 
        GOTO    QQQ
        
QHH1
        INCF    QH_L, F
        MOVF    QH_L, W
        SUBLW   0X3A
        BTFSS   STATUS, Z
        GOTO    QQQ
        
        MOVLW   0X30 
        MOVWF   QH_L 
        
        INCF    QH_H, F
               
QQQ
        DECFSZ  HELP, F
        GOTO    ZAEHL1
        RETURN

;*****************************************************************************
;*                              ZEIT ANZEIGEN OHNE : UND .                   *
;*****************************************************************************
ANZEIGE
        MOVF    QH_H, W
        SUBLW   0X30       ;VORNULL WEGMACHEN 
        BTFSS   STATUS, Z  ;ZERO-ABFRAGE BEI HIGH(1) IST ES GLEICH / BEI LOW (0) UNGLEICH
        GOTO    ANZEI1
        
        MOVLW   H'80'         
        CALL    BEFEHL
        MOVLW   0X20       ;LEERZEICHEN
        CALL    DATEN
        GOTO    ANZEI2
        
ANZEI1      MOVLW   H'80'         
            CALL    BEFEHL
            MOVF    QH_H, W            
            CALL    DATEN
            
ANZEI2      MOVLW   H'81'         
            CALL    BEFEHL
            MOVF    QH_L, W            
            CALL    DATEN

            MOVLW   H'83'         
            CALL    BEFEHL
            MOVF    QMIN_H, W            
            CALL    DATEN
            
            MOVLW   H'84'         
            CALL    BEFEHL
            MOVF    QMIN_L, W            
            CALL    DATEN        
        
            MOVLW   H'86'         
            CALL    BEFEHL
            MOVF    QSEC_H, W            
            CALL    DATEN
            
            MOVLW   H'87'         
            CALL    BEFEHL
            MOVF    QSEC_L, W            
            CALL    DATEN
              
            RETURN

;*****************************************************************************
;*                              ZEIT ANZEIGEN MIT : UND OHNE SEC .           *
;*****************************************************************************
ZONE_ANZEIGE
            MOVLW   H'80'         
            CALL    BEFEHL
            MOVLW   " "     
            CALL    DATEN
              
         MOVLW   H'08'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
         MOVWF   PCLATH
         CALL   VOR_ANZ ;ZAE1 STELLT
         MOVWF  MERK
         MOVLW   H'02'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
         MOVWF   PCLATH
         
         MOVLW   H'81'         
         CALL    BEFEHL
         MOVF    MERK, W            
         CALL    DATEN
         
         MOVLW   H'08'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
         MOVWF   PCLATH         
         CALL   H_ANZ ;ZAE1 STELLT
         MOVWF  MERK
         MOVLW   H'02'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
         MOVWF   PCLATH
         
         MOVF   MERK, W
         ANDLW  0X0F
         ADDLW  0X30
         MOVWF  MERK_L
         SWAPF  MERK, W
         ANDLW  0X0F
         ADDLW  0X30
         MOVWF  MERK_H
            
        MOVF    MERK_H, W
        SUBLW   0X30       ;VORNULL WEGMACHEN 
        BTFSS   STATUS, Z  ;ZERO-ABFRAGE BEI HIGH(1) IST ES GLEICH / BEI LOW (0) UNGLEICH
        GOTO    ZANZEI1
        
        MOVLW   H'82'         
        CALL    BEFEHL
        MOVLW   0X20       ;LEERZEICHEN
        CALL    DATEN
        GOTO    ZANZEI2
        
ZANZEI1     MOVLW   H'82'         
            CALL    BEFEHL
            MOVF    MERK_H, W            
            CALL    DATEN
            
ZANZEI2     MOVLW   H'83'         
            CALL    BEFEHL
            MOVF    MERK_L, W            
            CALL    DATEN

            MOVLW   H'84'         
            CALL    BEFEHL
            MOVLW   ":"           
            CALL    DATEN
            
       MOVLW   H'08'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
       MOVWF   PCLATH           
         CALL   MIN_ANZ ;ZAE1 STELLT
         MOVWF  MERK
       MOVLW   H'02'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
       MOVWF   PCLATH
         
         MOVF   MERK, W
         ANDLW  0X0F
         ADDLW  0X30
         MOVWF  MERK_L
         SWAPF  MERK, W
         ANDLW  0X0F
         ADDLW  0X30
         MOVWF  MERK_H            
      
            MOVLW   H'85'         
            CALL    BEFEHL
            MOVF    MERK_H, W            
            CALL    DATEN
            
            MOVLW   H'86'         
            CALL    BEFEHL
            MOVF    MERK_L, W            
            CALL    DATEN        
        
            MOVLW   H'87'         
            CALL    BEFEHL
            MOVLW   " "           
            CALL    DATEN
 
            RETURN

                    

;*****************************************************************************
;*                              UNTERPROG. AUSGEBEN AUF DOT-LCD-MODUL        *
;*****************************************************************************
DATEN       MOVWF   BIT
            
LL1     BCF     INTCON, GIE     ;INTERRUPT SPERREN // MUSS SO GEMACHT WERDEN!!! // NICHT NUR --> BCF  INTCON, GIE
        BTFSC   INTCON, GIE
        GOTO    LL1
        
            BCF	    RCSTA, SPEN		;DISABLE SERIAL PORT
 
            MOVF    BIT, W
            ANDLW   0XF0           
            MOVWF   PORTB

            BSF     PORTB, RS               ;ALS DATEN
            BSF     PORTB, EN

;ZEITSCHLEIFE 4SEC
            NOP                             ;T=4
            NOP                             ;T=4           
;ENDE ZEITSCHLEIFE
 
            BCF     PORTB, EN

;---------------------------------

;LOW 4BIT AUSGEBEN
            SWAPF   BIT, F    ;4MAL SCHIEBEN ODER VERTAUSCHEN            
 
            MOVF    BIT, W
            ANDLW   0XF0      
            MOVWF   PORTB

            BSF     PORTB, RS               ;ALS DATEN
            BSF     PORTB, EN

;ZEITSCHLEIFE 4SEC
            NOP                             ;T=4
            NOP                             ;T=4                         
;ENDE ZEITSCHLEIFE
 
            BCF     PORTB, EN

;ZEITSCHLEIFE 27SEC
            MOVLW   D'5'                   ;UNGEFAEHR 27SEC ZEITSCHLEIFE
            MOVWF   HELP2
DDDD1       NOP
            DECFSZ  HELP2, F                ;WIE OBEN  
            GOTO    DDDD1
;ENDE ZEITSCHLEIFE

            RETURN

;*****************************************************************************
;*                              UNTERPROG. AUSGEBEN AUF DOT-LCD-MODUL        *
;*****************************************************************************
BEFEHL      MOVWF   BIT
            
LL2     BCF     INTCON, GIE     ;INTERRUPT SPERREN // MUSS SO GEMACHT WERDEN!!! // NICHT NUR --> BCF  INTCON, GIE
        BTFSC   INTCON, GIE
        GOTO    LL2
        
            BCF	    RCSTA, SPEN		;DISABLE SERIAL PORT

            MOVF    BIT, W
            ANDLW   0XF0             
            MOVWF   PORTB

            BCF     PORTB, RS               ;ALS BEFEHL
            BSF     PORTB, EN

;ZEITSCHLEIFE 4SEC
            NOP                             ;T=4
            NOP                             ;T=4           
;ENDE ZEITSCHLEIFE
 
            BCF     PORTB, EN

;---------------------------------

;LOW 4BIT AUSGEBEN
            SWAPF   BIT, F    ;4MAL SCHIEBEN ODER VERTAUSCHEN            
 
            MOVF    BIT, W
            ANDLW   0XF0       
            MOVWF   PORTB

            BCF     PORTB, RS               ;ALS BEFEHL
            BSF     PORTB, EN

;ZEITSCHLEIFE 4SEC
            NOP                             ;T=4
            NOP                             ;T=4                         
;ENDE ZEITSCHLEIFE
 
            BCF     PORTB, EN

;ZEITSCHLEIFE 27SEC
            MOVLW   D'5'                   ;UNGEFAEHR 27SEC ZEITSCHLEIFE
            MOVWF   HELP2
BBBB1       NOP
            DECFSZ  HELP2, F                ;WIE OBEN  
            GOTO    BBBB1
;ENDE ZEITSCHLEIFE

            RETURN


;*****************************************************************************
;*                              1MSEC ZEITSCHLEIFE                           *
;*****************************************************************************
ZS1MSEC                 MOVWF   HELP

ZS1                     MOVLW   D'242'
                        MOVWF   TMR0                    
                        BCF     INTCON, TMR0IF          ;OVERFLOW = 0
                
ZS2                     BTFSS   INTCON, TMR0IF           
                        GOTO    ZS2                    

                        DECFSZ  HELP, F                 
                        GOTO    ZS1                    

                        RETURN

;ZEITBERECHNUNG FUER 1MS

;PRESCALER 64X  *  SYSTEM 4X  * TAKTZEIT ====> 64*4*0.271S=69,376SEC /DIE TAKTZEIT ERGIBT SICH AUS DEM QUARZ
;1MS : 69,376S= 14,41  GENOMMEN  14                                     
;ALSO 
;69S*D'14'=966SEC
;TMR0 ALSO D'256'-D'14'=D'242' ENTSPRICHT CA. 1MSEC
;242 DEZIMAL OBEN EINTRAGEN
                        
;*****************************************************************************
;*                              10MSEC ZEITSCHLEIFE                          *
;*****************************************************************************
ZS10MSEC                MOVWF   HELP

ZS10                    MOVLW   D'112'
                        MOVWF   TMR0                    
                        BCF     INTCON, TMR0IF          ;OVERFLOW = 0
                
ZS20                    BTFSS   INTCON, TMR0IF           
                        GOTO    ZS20                    

                        DECFSZ  HELP, F                 
                        GOTO    ZS10                    

                        RETURN

;ZEITBERECHNUNG FUER 1MS

;PRESCALER 64X  *  SYSTEM 4X  * TAKTZEIT ====> 64*4*0.271S=69,376SEC /DIE TAKTZEIT ERGIBT SICH AUS DEM QUARZ
;10MS : 69,376S= 144,14  GENOMMEN  144                                     
;ALSO 
;69S*D'144'=9,936MSEC
;TMR0 ALSO D'256'-D'144'=D'112' ENTSPRICHT CA. 10MSEC
;112 DEZIMAL OBEN EINTRAGEN
                         
;*****************************************************************************
;*                              5SEC ZEITSCHLEIFE TASTERABFRAGE              *
;*****************************************************************************
ZS5SEC_TASTER           BCF     SYSTEM, BIT2
                        
                        MOVLW   WARTE_SPEICHERN     ;0,5SEC *  X  ===> SIEHE OBEN AM ANFANG BEI EINSTELLUNGEN
                        MOVWF   MERK
                        
ZS300                   MOVLW   D'50'
                        MOVWF   HELP

ZS100                   MOVLW   D'112'
                        MOVWF   TMR0                    
                        BCF     INTCON, TMR0IF          ;OVERFLOW = 0
                
ZS200                   BTFSC   INTCON, TMR0IF      
                        GOTO    ZS201                    
                                    
            BTFSS   PORTA, BIT2 ;HOCH STELLEN
            RETURN
            BTFSS   PORTA, BIT3 ;RUNTER STELLEN
            RETURN
            GOTO    ZS200
                        
                        
ZS201                   DECFSZ  HELP, F                 
                        GOTO    ZS100                          

                        DECFSZ  MERK, F                 
                        GOTO    ZS300  
                        
                        BSF     SYSTEM, BIT2 ;ENDE ZS
                        RETURN       
;*****************************************************************************
;*                              ZEIT KORREKTUR ALSO +1H +2H +3H....          *
;*****************************************************************************
ZONE_H 
        MOVF    MK, W
        SUBLW   D'0'
        BTFSS   STATUS, Z
        GOTO    ZEIT_A
        RETURN
 
        
ZEIT_A  MOVF    QH_H, W
        SUBLW   0X32
        BTFSS   STATUS, Z
        GOTO    ZEIT_B
        
        INCF    QH_L, F
        MOVF    QH_L, W
        SUBLW   0X34
        BTFSS   STATUS, Z
        GOTO    Z1
        
        MOVLW   0X30
        MOVWF   QH_L
        MOVWF   QH_H
        GOTO    Z1
        
ZEIT_B  INCF    QH_L, F
        MOVF    QH_L, W
        SUBLW   0X3A
        BTFSS   STATUS, Z
        GOTO    Z1
        
        INCF    QH_H, F 
        MOVLW   0X30
        MOVWF   QH_L
                
Z1      DECFSZ  MK, F
        GOTO    ZEIT_A
        RETURN
                       
        
;*****************************************************************************
;*                              ZEIT KORREKTUR ALSO +30MIN / +15MIN          *
;*****************************************************************************
ZONE_MIN
        MOVF    MK, W
        SUBLW   D'0'
        BTFSS   STATUS, Z
        GOTO    ZEIT_A_MIN
        RETURN               

ZEIT_A_MIN        
        INCF    QMIN_L, F
        MOVF    QMIN_L, W
        SUBLW   0X3A
        BTFSS   STATUS, Z
        GOTO    Z1_MIN
        
        MOVLW   0X30
        MOVWF   QMIN_L
        
        INCF    QMIN_H, F
        MOVF    QMIN_H, W
        SUBLW   0X36
        BTFSS   STATUS, Z
        GOTO    Z1_MIN
        
        MOVLW   0X30
        MOVWF   QMIN_H
        MOVWF   QMIN_L
        
;----------------
        MOVF    QH_H, W
        SUBLW   0X32
        BTFSS   STATUS, Z
        GOTO    ZEIT_B_MIN
        
        INCF    QH_L, F
        MOVF    QH_L, W
        SUBLW   0X34
        BTFSS   STATUS, Z
        GOTO    Z1_MIN
        
        MOVLW   0X30
        MOVWF   QH_L
        MOVWF   QH_H
        GOTO    Z1_MIN
        
ZEIT_B_MIN
        INCF    QH_L, F
        MOVF    QH_L, W
        SUBLW   0X3A
        BTFSS   STATUS, Z
        GOTO    Z1_MIN
        
        INCF    QH_H, F 
        MOVLW   0X30
        MOVWF   QH_L
                
Z1_MIN      
        DECFSZ  MK, F
        GOTO    ZEIT_A_MIN
        RETURN
        
;*****************************************************************************
;*                              LAUFSCHRIFT                                  *
;*****************************************************************************            
LAUFSCHRIFT
            NOP
ANFANG 
            MOVLW   LAUF_ZEIT
            CALL    ZS10MSEC
     
            MOVLW   H'01'                   ;CLEAR DISPLAY
            CALL    BEFEHL
;ZEITSCHLEIFE VON 2MSEC, MUSS SEIN WEGEN LSCHEN
            MOVLW   D'4'
            CALL    ZS1MSEC    

            DECFSZ  MAL, F      ;WIEVIEL MAL DURCHLUFE
            GOTO    WEITER_X
            CLRF    AUSWAHL     ;TEXT_0 / TEXT_1 AUSWAHL LSCHEN
            RETURN
            
WEITER_X            
                    CLRF    ZAE2            ;ZAE ZHLER MIT BEGINN NULL LADEN
                    CLRF    NR_HELP         
                    CLRF    ZEILE
                    CLRF    NEU 
                    MOVLW   D'1'
                    MOVWF   NR
                    
NEUES_ZEICHEN       
                    MOVLW   H'0C'           ;ADRESSE SPEICHERN NEUES PCLATH AM ANFANG /// *.LST FILE ADRESSE KONTROLLIEREN !!!!
                    MOVWF   PCLATH                  
                    CALL    TABELLE
                    MOVWF   TXT
                    MOVLW   H'07'           ;ADRESSE SPEICHERN NEUES PCLATH AM ANFANG /// *.LST FILE ADRESSE KONTROLLIEREN !!!!
                    MOVWF   PCLATH

                    MOVLW   0XFF            ;TXT-ENDE-ERKENNUNG
                    SUBWF   TXT, W
                    BTFSC   STATUS, Z
                    GOTO    ANFANG         ;SCHLUSS / ES HAT DAS 0XFF ERKANNT ALS ENDEKENNZEICHEN IN DER TABELLE

;AUF DOGM ANZEIGEN
                    MOVF    NR, W
                    SUBLW   H'87'
                    MOVWF   LCD_ADR

WEITER3             INCF    LCD_ADR, F
                    INCF    ZAE2, F

                    MOVF    LCD_ADR, W          ;NEUES HINZUGEKOMMENES ZEICHEN
                    CALL    BEFEHL
                    MOVF    TXT, W
                    CALL    DATEN

                    BTFSS   ZEILE, BIT0
                    GOTO    WEITER1

                    MOVF    ZAE2, W
                    SUBLW   ANZAHL1 
                    BTFSC   STATUS, Z
                    GOTO    VOLL                ;ZEILE VOLL

                    INCF    NR_HELP, F
                    MOVLW   H'0C'           ;ADRESSE SPEICHERN NEUES PCLATH AM ANFANG /// *.LST FILE ADRESSE KONTROLLIEREN !!!!
                    MOVWF   PCLATH                  
                    CALL    TABELLE
                    MOVWF   TXT
                    MOVLW   H'07'           ;ADRESSE SPEICHERN NEUES PCLATH AM ANFANG /// *.LST FILE ADRESSE KONTROLLIEREN !!!!
                    MOVWF   PCLATH

                    MOVLW   0XFF            ;TXT-ENDE-ERKENNUNG
                    SUBWF   TXT, W
                    BTFSC   STATUS, Z
                    GOTO    ANFANG         ;SCHLUSS / ES HAT DAS 0XFF ERKANNT ALS ENDEKENNZEICHEN IN DER TABELLE

                    GOTO    WEITER3


;ENDE ERKENNUNG FR ZEILE BESCHREIBEN
WEITER1             MOVF    ZAE2, W
                    SUBLW   ANZAHL 
                    BTFSC   STATUS, Z
                    GOTO    VOLL                ;ZEILE VOLL

                    MOVF    ZAE2, W
                    SUBWF   NR, W
                    BTFSC   STATUS, Z
                    GOTO    ZEITSCHLEIFE  
                   

;NEUES ZEICHEN AUF ZEILE
WEITER4             INCF    NR_HELP, F
                    MOVLW   H'0C'           ;ADRESSE SPEICHERN NEUES PCLATH AM ANFANG /// *.LST FILE ADRESSE KONTROLLIEREN !!!!
                    MOVWF   PCLATH                  
                    CALL    TABELLE
                    MOVWF   TXT
                    MOVLW   H'07'           ;ADRESSE SPEICHERN NEUES PCLATH AM ANFANG /// *.LST FILE ADRESSE KONTROLLIEREN !!!!
                    MOVWF   PCLATH

                    MOVLW   0XFF            ;TXT-ENDE-ERKENNUNG
                    SUBWF   TXT, W
                    BTFSC   STATUS, Z
                    GOTO    ANFANG         ;SCHLUSS / ES HAT DAS 0XFF ERKANNT ALS ENDEKENNZEICHEN IN DER TABELLE

                    GOTO    WEITER3


VOLL        BSF     ZEILE, BIT0

ZEITSCHLEIFE
            MOVLW   LAUF_ZEIT
            CALL    ZS10MSEC

            BTFSC   ZEILE, BIT0
            GOTO    VOLLA

                    INCF    NR, F
                    CLRF    NR_HELP
                    CLRF    ZAE2
                    GOTO    NEUES_ZEICHEN



VOLLA               MOVLW   D'8'
                    MOVWF   NR

                    INCF    NEU, F
                    MOVF    NEU, W
                    MOVWF   NR_HELP

                    CLRF    ZAE2
                    GOTO    NEUES_ZEICHEN

            
;*****************************************************************************
;*                              PIEPS                                        *
;*****************************************************************************
PIEPS
        BTFSS   ALARM, BIT0
        RETURN
                    
        MOVLW   0X30
        SUBWF   QMIN_H, W
        BTFSS   STATUS, Z
        GOTO    WEI1

        MOVLW   0X30
        SUBWF   QMIN_L, W
        BTFSS   STATUS, Z
        GOTO    WEI1

        MOVLW   0X30
        SUBWF   QSEC_H, W
        BTFSS   STATUS, Z
        GOTO    WEI1
        
        MOVLW   0X30
        SUBWF   QSEC_L, W
        BTFSS   STATUS, Z
        GOTO    WEI1
 
        
        MOVF    QH_H, W
        ANDLW   0X0F
        MOVWF   PH
        SWAPF   PH, F
 
        MOVF    QH_L, W
        ANDLW   0X0F
        ADDWF   PH, F        

        MOVLW   PIEP_AB_HIER        
        SUBWF   PH, W
        BTFSS   STATUS, C   ;GRER GLEICH ALS 8UHR DANN CARRY AUF HIGH
        GOTO    WEI1
        MOVLW   PIEP_BIS_HIER+1       
        SUBWF   PH, W
        BTFSC   STATUS, C   ;KLEINER ALS 22UHR (ALSO 21UHR GEHT NOCH) DANN CARRY AUF LOW
        GOTO    WEI1
        
        BSF     PORTA, BIT1 ;SUMMER EIN
        BSF     DENK, BIT0 ;MERKER TON EIN
        RETURN
        
WEI1    BCF     PORTA, BIT1 ;SUMMER AUS
        BCF     DENK, BIT0 ;MERKER TON AUS
        RETURN
     
            
;*****************************************************************************
;*                              WECKER EIN + AUS                             *
;*****************************************************************************
WECK_SIGNAL
        BTFSS   WECK, BIT0
        RETURN
                    
        MOVF    WMIN_H, W
        SUBWF   QMIN_H, W
        BTFSS   STATUS, Z
        GOTO    WEI11

        MOVF    WMIN_L, W
        SUBWF   QMIN_L, W
        BTFSS   STATUS, Z
        GOTO    WEI11

                    
        MOVF    WH_H, W
        SUBWF   QH_H, W
        BTFSS   STATUS, Z
        GOTO    WEI11

        MOVF    WH_L, W
        SUBWF   QH_L, W
        BTFSS   STATUS, Z
        GOTO    WEI11
         
        BTFSS   AUS, BIT0 ;MERKER BLEIBT AUS
        GOTO    WEIXX
        BCF     PORTA, BIT1 ;SUMMER AUS
        RETURN

WEIXX 
        BSF     PORTA, BIT1 ;SUMMER EIN
        RETURN
   
WEI11
        BCF     AUS, BIT0 ;BLEIBT AUS ZURCK GESETZT
        BCF     PORTA, BIT1 ;SUMMER AUS
        RETURN
      
        
;*****************************************************************************
;*                              UNTERPROGRAMM                                *
;*                       WECK-ANZEIGE                                        *
;*****************************************************************************
WECK_ANZEI      
       
;WECKZEIT ANZEIGEN
                MOVLW   0X82
                CALL    BEFEHL
                MOVF    WH_H, W
                SUBLW   0X30
                BTFSS   STATUS, Z
                GOTO    AYX
                
                MOVLW   " "
                GOTO    MYX
                
AYX             MOVF    WH_H, W
MYX             CALL    DATEN
                
                MOVLW   0X83
                CALL    BEFEHL
                MOVF    WH_L, W
                CALL    DATEN
                
                MOVLW   0X85
                CALL    BEFEHL
                MOVF    WMIN_H, W
                CALL    DATEN
                
                MOVLW   0X86
                CALL    BEFEHL
                MOVF    WMIN_L, W
                CALL    DATEN
 
                RETURN
                
;*****************************************************************************
;*                              UNTERPROGRAMM                                *
;*                       AUFWRTS STELLEN WECKZEIT                           *
;*****************************************************************************
WECK_AUF
                
        INCF    WMIN_L, F
        MOVF    WMIN_L, W
        SUBLW   0X3A
        BTFSS   STATUS, Z
        RETURN
      
        MOVLW   0X30
        MOVWF   WMIN_L
                
        INCF    WMIN_H, F
        MOVF    WMIN_H, W
        SUBLW   0X36
        BTFSS   STATUS, Z
        RETURN
            
        MOVLW   0X30
        MOVWF   WMIN_H
     
        MOVF    WH_H, W
        SUBLW   0X32
        BTFSS   STATUS, Z
        GOTO    WQHH1
        
        INCF    WH_L, F
        MOVF    WH_L, W
        SUBLW   0X34
        BTFSS   STATUS, Z
        RETURN
         
        MOVLW   0X30
        MOVWF   WH_L
        MOVWF   WH_H 
        RETURN
        
WQHH1
        INCF    WH_L, F
        MOVF    WH_L, W
        SUBLW   0X3A
        BTFSS   STATUS, Z
        RETURN
        
        MOVLW   0X30 
        MOVWF   WH_L 
        
        INCF    WH_H, F
               
WQQQ    RETURN
               
                
;*****************************************************************************
;*                              UNTERPROGRAMM                                *
;*                       ABWRTS STELLEN WECKZEIT                           *
;*****************************************************************************
WECK_AB
        MOVF    WH_H, W
        SUBLW   0X30
        BTFSS   STATUS, Z
        GOTO    WSS
        
        MOVF    WH_L, W
        SUBLW   0X30
        BTFSS   STATUS, Z
        GOTO    WSS
        
        MOVF    WMIN_H, W
        SUBLW   0X30
        BTFSS   STATUS, Z
        GOTO    WSS
        
        MOVF    WMIN_L, W
        SUBLW   0X30
        BTFSS   STATUS, Z
        GOTO    WSS
        
        MOVLW   0X32
        MOVWF   WH_H
        MOVLW   0X33
        MOVWF   WH_L
        
        MOVLW   0X39
        MOVWF   WMIN_L
        MOVLW   0X35
        MOVWF   WMIN_H
        RETURN
        
WSS        
        DECF    WMIN_L, F
        MOVF    WMIN_L, W
        SUBLW   0X2F
        BTFSS   STATUS, Z
        RETURN
      
        MOVLW   0X39
        MOVWF   WMIN_L
                
        DECF    WMIN_H, F
        MOVF    WMIN_H, W
        SUBLW   0X2F
        BTFSS   STATUS, Z
        RETURN
            
        MOVLW   0X35
        MOVWF   WMIN_H
 
;;;;;;;;;;;;;;;       
        DECF    WH_L, F
        MOVF    WH_L, W
        SUBLW   0X2F
        BTFSS   STATUS, Z
        RETURN  
        
        MOVLW   0X39
        MOVWF   WH_L
        
        DECF    WH_H, F
        MOVF    WH_H, W
        SUBLW   0X2F
        BTFSS   STATUS, Z
        RETURN
        
        MOVLW   0X30
        MOVWF   WH_L
        MOVLW   0X30
        MOVWF   WH_H 
        
        RETURN

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
                
                
 
 
                
                
                        
    ORG 0X0800
;*****************************************************************************
;*                              UNTERPROGRAMM                                *
;*                       MINUTEN ZEITZONE                                    *
;*****************************************************************************
MIN_BERECH        
         MOVLW   H'08'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
         MOVWF   PCLATH
     
    MOVF    ZAE1, W     ; SPRUNGDISTANZ
    ADDWF   PCL,F       ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  
  
;----------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------
        
;JETZT KOMMT DER TEXT
;MIT RETLW 
;            ;ZAE1               
 RETLW D'00' ;00        UTC-11H
 RETLW D'00' ;01        UTC-10H 
 RETLW D'30' ;02        UTC-9H30MIN
 RETLW D'00' ;03        UTC-9H        
 RETLW D'00' ;04        UTC-8H
 RETLW D'00' ;05        UTC-7H
 RETLW D'00' ;06        UTC-6H
 RETLW D'00' ;07        UTC-5H
 RETLW D'00' ;08        UTC-4H 
 RETLW D'00' ;09        UTC-3H      
 RETLW D'30' ;10        UTC-2H30MIN
 RETLW D'00' ;11        UTC-2H   
 RETLW D'00' ;12        UTC-1H 
 RETLW D'00' ;13        UTC+0H
 RETLW D'00' ;14        UTC+1H
 RETLW D'00' ;15        UTC+2H
 RETLW D'00' ;16        UTC+3H
 RETLW D'30' ;17        UTC+3H30MIN 
 RETLW D'00' ;18        UTC+4H
 RETLW D'30' ;19        UTC+4H30MIN
 RETLW D'00' ;20        UTC+5H
 RETLW D'30' ;21        UTC+5H30MIN
 RETLW D'45' ;22        UTC+5H45MIN
 RETLW D'00' ;23        UTC+6H
 RETLW D'30' ;24        UTC+6H30MIN
 RETLW D'00' ;25        UTC+7H   
 RETLW D'00' ;26        UTC+8H  
 RETLW D'00' ;27        UTC+9H
 RETLW D'30' ;28        UTC+9H30MIN 
 RETLW D'00' ;29        UTC+10H   
 RETLW D'00' ;30        UTC+11H    
 RETLW D'00' ;31        UTC+12H 
 RETLW D'00' ;32        UTC+13H
 RETLW D'45' ;33        UTC+13H45MIN   
 RETLW D'00' ;34        UTC+14H                            
                        
 RETLW 0XFF ;                  
       
                         
                        
;*****************************************************************************
;*                              UNTERPROGRAMM                                *
;*                       STUNDEN ZEITZONE                                    *
;*****************************************************************************
H_BERECH
         MOVLW   H'08'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
         MOVWF   PCLATH 
         
    MOVF    ZAE1, W     ; SPRUNGDISTANZ
    ADDWF   PCL,F       ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  
  
;----------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------
        
;JETZT KOMMT DER TEXT
;MIT RETLW 
;            ;ZAE1               
 RETLW D'13' ;00        UTC-11H
 RETLW D'14' ;01        UTC-10H 
 RETLW D'14' ;02        UTC-9H30MIN
 RETLW D'15' ;03        UTC-9H        
 RETLW D'16' ;04        UTC-8H
 RETLW D'17' ;05        UTC-7H
 RETLW D'18' ;06        UTC-6H
 RETLW D'19' ;07        UTC-5H
 RETLW D'20' ;08        UTC-4H 
 RETLW D'21' ;09        UTC-3H      
 RETLW D'21' ;10        UTC-2H30MIN
 RETLW D'22' ;11        UTC-2H   
 RETLW D'23' ;12        UTC-1H 
 RETLW D'00' ;13        UTC+0H
 RETLW D'01' ;14        UTC+1H
 RETLW D'02' ;15        UTC+2H
 RETLW D'03' ;16        UTC+3H
 RETLW D'03' ;17        UTC+3H30MIN 
 RETLW D'04' ;18        UTC+4H
 RETLW D'04' ;19        UTC+4H30MIN
 RETLW D'05' ;20        UTC+5H
 RETLW D'05' ;21        UTC+5H30MIN
 RETLW D'05' ;22        UTC+5H45MIN
 RETLW D'06' ;23        UTC+6H
 RETLW D'06' ;24        UTC+6H30MIN
 RETLW D'07' ;25        UTC+7H   
 RETLW D'08' ;26        UTC+8H  
 RETLW D'09' ;27        UTC+9H
 RETLW D'09' ;28        UTC+9H30MIN 
 RETLW D'10' ;29        UTC+10H   
 RETLW D'11' ;30        UTC+11H    
 RETLW D'12' ;31        UTC+12H 
 RETLW D'13' ;32        UTC+13H
 RETLW D'13' ;33        UTC+13H45MIN   
 RETLW D'14' ;34        UTC+14H                            
                        
 RETLW 0XFF ;                        
                        
;*****************************************************************************
;*                              UNTERPROGRAMM                                *
;*                       STUNDEN ZEITZONE ANZEIGEN                           *
;*****************************************************************************
H_ANZ
         MOVLW   H'08'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
         MOVWF   PCLATH 
         
    MOVF    ZAE1, W     ; SPRUNGDISTANZ
    ADDWF   PCL,F       ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  
  
;----------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------
        
;JETZT KOMMT DER TEXT
;MIT RETLW 
;            ;ZAE1               
 RETLW 0X11 ;00        UTC-11H
 RETLW 0X10 ;01        UTC-10H 
 RETLW 0X09 ;02        UTC-9H30MIN
 RETLW 0X09 ;03        UTC-9H        
 RETLW 0X08 ;04        UTC-8H
 RETLW 0X07 ;05        UTC-7H
 RETLW 0X06 ;06        UTC-6H
 RETLW 0X05 ;07        UTC-5H
 RETLW 0X04 ;08        UTC-4H 
 RETLW 0X03 ;09        UTC-3H      
 RETLW 0X02 ;10        UTC-2H30MIN
 RETLW 0X02 ;11        UTC-2H   
 RETLW 0X01 ;12        UTC-1H 
 RETLW 0X00 ;13        UTC+0H
 RETLW 0X01 ;14        UTC+1H
 RETLW 0X02 ;15        UTC+2H
 RETLW 0X03 ;16        UTC+3H
 RETLW 0X03 ;17        UTC+3H30MIN 
 RETLW 0X04 ;18        UTC+4H
 RETLW 0X04 ;19        UTC+4H30MIN
 RETLW 0X05 ;20        UTC+5H
 RETLW 0X05 ;21        UTC+5H30MIN
 RETLW 0X05 ;22        UTC+5H45MIN
 RETLW 0X06 ;23        UTC+6H
 RETLW 0X06 ;24        UTC+6H30MIN
 RETLW 0X07 ;25        UTC+7H   
 RETLW 0X08 ;26        UTC+8H  
 RETLW 0X09 ;27        UTC+9H
 RETLW 0X09 ;28        UTC+9H30MIN 
 RETLW 0X10 ;29        UTC+10H   
 RETLW 0X11 ;30        UTC+11H    
 RETLW 0X12 ;31        UTC+12H 
 RETLW 0X13 ;32        UTC+13H
 RETLW 0X13 ;33        UTC+13H45MIN   
 RETLW 0X14 ;34        UTC+14H                            
                        
 RETLW 0XFF ;                        

;*****************************************************************************
;*                              UNTERPROGRAMM                                *
;*                       MINUTEN ZEITZONE ANZEIGEN                           *
;*****************************************************************************
MIN_ANZ
         MOVLW   H'08'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
         MOVWF   PCLATH 
         
    MOVF    ZAE1, W     ; SPRUNGDISTANZ
    ADDWF   PCL,F       ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  
  
;----------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------
        
;JETZT KOMMT DER TEXT
;MIT RETLW 
;            ;ZAE1               
 RETLW 0X00 ;00        UTC-11H
 RETLW 0X00 ;01        UTC-10H 
 RETLW 0X30 ;02        UTC-9H30MIN
 RETLW 0X00 ;03        UTC-9H        
 RETLW 0X00 ;04        UTC-8H
 RETLW 0X00 ;05        UTC-7H
 RETLW 0X00 ;06        UTC-6H
 RETLW 0X00 ;07        UTC-5H
 RETLW 0X00 ;08        UTC-4H 
 RETLW 0X00 ;09        UTC-3H      
 RETLW 0X30 ;10        UTC-2H30MIN
 RETLW 0X00 ;11        UTC-2H   
 RETLW 0X00 ;12        UTC-1H 
 RETLW 0X00 ;13        UTC+0H
 RETLW 0X00 ;14        UTC+1H
 RETLW 0X00 ;15        UTC+2H
 RETLW 0X00 ;16        UTC+3H
 RETLW 0X30 ;17        UTC+3H30MIN 
 RETLW 0X00 ;18        UTC+4H
 RETLW 0X30 ;19        UTC+4H30MIN
 RETLW 0X00 ;20        UTC+5H
 RETLW 0X30 ;21        UTC+5H30MIN
 RETLW 0X45 ;22        UTC+5H45MIN
 RETLW 0X00 ;23        UTC+6H
 RETLW 0X30 ;24        UTC+6H30MIN
 RETLW 0X00 ;25        UTC+7H   
 RETLW 0X00 ;26        UTC+8H  
 RETLW 0X00 ;27        UTC+9H
 RETLW 0X30 ;28        UTC+9H30MIN 
 RETLW 0X00 ;29        UTC+10H   
 RETLW 0X00 ;30        UTC+11H    
 RETLW 0X00 ;31        UTC+12H 
 RETLW 0X00 ;32        UTC+13H
 RETLW 0X45 ;33        UTC+13H45MIN   
 RETLW 0X00 ;34        UTC+14H                            
                        
 RETLW 0XFF ;                        

;*****************************************************************************
;*                              UNTERPROGRAMM                                *
;*                       VORZEICHEN ZEITZONE ANZEIGEN                        *
;*****************************************************************************
VOR_ANZ
         MOVLW   H'08'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
         MOVWF   PCLATH 
         
    MOVF    ZAE1, W     ; SPRUNGDISTANZ
    ADDWF   PCL,F       ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  
  
;----------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------
        
;JETZT KOMMT DER TEXT
;MIT RETLW 
;          ;ZAE1               
 RETLW "-" ;00        UTC-11H
 RETLW "-" ;01        UTC-10H 
 RETLW "-" ;02        UTC-9H30MIN
 RETLW "-" ;03        UTC-9H        
 RETLW "-" ;04        UTC-8H
 RETLW "-" ;05        UTC-7H
 RETLW "-" ;06        UTC-6H
 RETLW "-" ;07        UTC-5H
 RETLW "-" ;08        UTC-4H 
 RETLW "-" ;09        UTC-3H      
 RETLW "-" ;10        UTC-2H30MIN
 RETLW "-" ;11        UTC-2H   
 RETLW "-" ;12        UTC-1H 
 RETLW " " ;13        UTC+0H
 RETLW "+" ;14        UTC+1H
 RETLW "+" ;15        UTC+2H
 RETLW "+" ;16        UTC+3H
 RETLW "+" ;17        UTC+3H30MIN 
 RETLW "+" ;18        UTC+4H
 RETLW "+" ;19        UTC+4H30MIN
 RETLW "+" ;20        UTC+5H
 RETLW "+" ;21        UTC+5H30MIN
 RETLW "+" ;22        UTC+5H45MIN
 RETLW "+" ;23        UTC+6H
 RETLW "+" ;24        UTC+6H30MIN
 RETLW "+" ;25        UTC+7H   
 RETLW "+" ;26        UTC+8H  
 RETLW "+" ;27        UTC+9H
 RETLW "+" ;28        UTC+9H30MIN 
 RETLW "+" ;29        UTC+10H   
 RETLW "+" ;30        UTC+11H    
 RETLW "+" ;31        UTC+12H 
 RETLW "+" ;32        UTC+13H
 RETLW "+" ;33        UTC+13H45MIN   
 RETLW "+" ;34        UTC+14H                            
                        
 RETLW 0XFF ;                        

                                               
     ORG 0X0C00
;*****************************************************************************
;*                              TABELLENAUSWAHL                              *
;*****************************************************************************
TABELLE             
         MOVLW   H'0C'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
         MOVWF   PCLATH
     
                    BTFSS   AUSWAHL_TXT, BIT0 
                    GOTO    T1
                    CALL    TEXT_0
                    RETURN

T1                  BTFSS   AUSWAHL_TXT, BIT1
                    GOTO    T2
                                        
                             MOVLW   H'0E'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
                             MOVWF   PCLATH
                    CALL    TEXT_1
                    
T2                  BTFSS   AUSWAHL_TXT, BIT2
                    GOTO    T3
                    CALL    TEXT_2
                    
T3                  BTFSS   AUSWAHL_TXT, BIT3
                    GOTO    T5
                    CALL    TEXT_3
                    RETURN
                    
T5                  BTFSS   AUSWAHL_TXT, BIT5
                    GOTO    T6
                    
                             MOVLW   H'0D'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
                             MOVWF   PCLATH
                    CALL    TEXT_5
                    RETURN
                    
T6                  BTFSS   AUSWAHL_TXT, BIT6
                    GOTO    T7
                    
                             MOVLW   H'0D'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
                             MOVWF   PCLATH
                    CALL    TEXT_6
                    RETURN 
                  
T7                  BTFSS   AUSWAHL_TXT, BIT7
                    GOTO    T8
                    
                             MOVLW   H'0D'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
                             MOVWF   PCLATH
                    CALL    TEXT_7
                    RETURN 
                  
T8                  BTFSS   AUSWAHL_TXT, BIT4
                    RETURN
                    
                             MOVLW   H'0E'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
                             MOVWF   PCLATH
                    CALL    TEXT_4
                    RETURN                     
;*****************************************************************************
;*                              UNTERPROGRAMM                                *
;*                       TEXT ZEILENWEISE LADEN                              *
;*****************************************************************************
TEXT_0
    MOVF    NR_HELP, W  ; SPRUNGDISTANZ
    ADDWF   PCL,F       ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  

    
;----------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------
        
;JETZT KOMMT DER TEXT
;RETLW " "    (SPACE/LEERZEICHEN) IST DIE PAUSE ZWISCHEN DEN WOERTERN

    RETLW "G"  
    RETLW "P"
    RETLW "S"
    RETLW "-"
    RETLW "U"
    RETLW 0X68  ;H           
    RETLW 0X72  ;R
    RETLW 0X65  ;E    
    RETLW 0X6E  ;N
    RETLW "-"
    RETLW "W"  
    RETLW 0X65  ;E
    RETLW 0X63  ;C
    RETLW 0X6B  ;K
    RETLW 0X65  ;E           
    RETLW 0X72  ;R

    RETLW " "    
    RETLW " "    
    RETLW " "    
    RETLW " "
    RETLW " "
    
    ;RETLW " "    
    ;RETLW " "    
    
    RETLW 0XFF
    
;*****************************************************************************
;*                              UNTERPROGRAMM                                *
;*                       TEXT ZEILENWEISE LADEN                              *
;*****************************************************************************
TEXT_2
    MOVF    NR_HELP, W  ; SPRUNGDISTANZ
    ADDWF   PCL,F       ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  

    
;----------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------
        
;JETZT KOMMT DER TEXT
;RETLW " "    (SPACE/LEERZEICHEN) IST DIE PAUSE ZWISCHEN DEN WOERTERN

    RETLW "S"  
    RETLW 0X74 ;T
    RETLW 0X75 ;U
    RETLW 0X6E ;N
    RETLW 0X64 ;D
    RETLW 0X65 ;E
    RETLW 0X6E ;N
    RETLW "-"
    RETLW "P"
    RETLW 0X69 ;I
    RETLW 0X65 ;E
    RETLW 0X70 ;P
    RETLW 0X73 ;S
 
    RETLW " "
    
    ;RETLW 0X69 ;I 
    ;RETLW 0X73 ;S
    ;RETLW 0X74 ;T
    
    ;RETLW " "

    ;RETLW 0X6A ;J
    ;RETLW 0X65 ;E    
    ;RETLW 0X74 ;T
    ;RETLW 0X7A ;Z
    ;RETLW 0X74 ;T

    ;RETLW " "

    RETLW "E"
    RETLW "I"    
    RETLW "N"
    ;RETLW "."
    
    RETLW " "    
    RETLW " "    
    RETLW " "
    RETLW " "
    RETLW " "
    
    ;RETLW " "    
    ;RETLW " "    
    
    RETLW 0XFF
    
;*****************************************************************************
;*                              UNTERPROGRAMM                                *
;*                       TEXT ZEILENWEISE LADEN                              *
;*****************************************************************************
TEXT_3
    MOVF    NR_HELP, W  ; SPRUNGDISTANZ
    ADDWF   PCL,F       ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  

    
;----------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------
        
;JETZT KOMMT DER TEXT
;RETLW " "    (SPACE/LEERZEICHEN) IST DIE PAUSE ZWISCHEN DEN WOERTERN

    RETLW "S"  
    RETLW 0X74 ;T
    RETLW 0X75 ;U
    RETLW 0X6E ;N
    RETLW 0X64 ;D
    RETLW 0X65 ;E
    RETLW 0X6E ;N
    RETLW "-"
    RETLW "P"
    RETLW 0X69 ;I
    RETLW 0X65 ;E
    RETLW 0X70 ;P
    RETLW 0X73 ;S
 
    RETLW " "
    
    ;RETLW 0X69 ;I 
    ;RETLW 0X73 ;S
    ;RETLW 0X74 ;T
    
    RETLW " "

    ;RETLW 0X6A ;J
    ;RETLW 0X65 ;E    
    ;RETLW 0X74 ;T
    ;RETLW 0X7A ;Z
    ;RETLW 0X74 ;T

    ;RETLW " "

    RETLW "A"
    RETLW "U"    
    RETLW "S"
    ;RETLW "."
    
    RETLW " "    
    RETLW " "    
    RETLW " "
    RETLW " "
    RETLW " " 
    
    ;RETLW " "    
    ;RETLW " "    
    
    RETLW 0XFF                       

    ORG 0X0D00
;*****************************************************************************
;*                              UNTERPROGRAMM                                *
;*                       TEXT ZEILENWEISE LADEN                              *
;*****************************************************************************
TEXT_5
                             MOVLW   H'0D'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
                             MOVWF   PCLATH
    MOVF    NR_HELP, W  ; SPRUNGDISTANZ
    ADDWF   PCL,F       ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  

    
;----------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------
        
;JETZT KOMMT DER TEXT
;RETLW " "    (SPACE/LEERZEICHEN) IST DIE PAUSE ZWISCHEN DEN WOERTERN


    ;RETLW "D"  
    ;RETLW 0X69 ;I
    ;RETLW 0X65 ;E
    ;RETLW 0X73 ;S
    ;RETLW 0X65 ;E
   
    ;RETLW " "
    
    RETLW "W"
    RETLW 0X65 ;E
    RETLW 0X63 ;C
    RETLW 0X6B ;K
    RETLW "-"
    RETLW "Z"           
    RETLW 0X65 ;E    
    RETLW 0X69 ;I           
    RETLW 0X74 ;T
    
    ;RETLW " "
    
    ;RETLW 0X69 ;I 
    ;RETLW 0X73 ;S
    ;RETLW 0X74 ;T
    
    ;RETLW " "

    ;RETLW 0X6A ;J
    ;RETLW 0X65 ;E    
    ;RETLW 0X74 ;T
    ;RETLW 0X7A ;Z
    ;RETLW 0X74 ;T

    ;RETLW " "
    
    ;RETLW 0X65 ;E
    ;RETLW 0X69 ;I           
    ;RETLW 0X6E ;N    
    ;RETLW 0X67 ;G           
    ;RETLW 0X65 ;E
    ;RETLW 0X73 ;S
    ;RETLW 0X74 ;T
    ;RETLW 0X65 ;E
    ;RETLW 0X6C ;L
    ;RETLW 0X6C ;L           
    ;RETLW 0X74 ;T         
    
    ;RETLW "."
    
    ;RETLW " "
    
    ;RETLW "M"
    ;RETLW 0X61 ;A           
    ;RETLW 0X6E ;N
    
    ;RETLW " "
    
    ;RETLW 0X6B ;K
    ;RETLW 0X94 ;
    ;RETLW 0X6E ;N
    ;RETLW 0X6E ;N
    ;RETLW 0X74 ;T
    ;RETLW 0X65 ;E
    ;RETLW " "
        
    ;RETLW 0X84 ;
    ;RETLW 0X6E ;N           
    ;RETLW 0X64 ;D    
    ;RETLW 0X65 ;E           
    ;RETLW 0X72 ;R
    ;RETLW 0X6E ;N

    ;RETLW 0X21 ;!

    RETLW " "    
    RETLW " "    
    RETLW " "
    RETLW " "
    RETLW " "    
    
    ;RETLW " "    
    ;RETLW " "    
    
    RETLW 0XFF
    
;*****************************************************************************
;*                              UNTERPROGRAMM                                *
;*                       TEXT ZEILENWEISE LADEN                              *
;*****************************************************************************
TEXT_6
                             MOVLW   H'0D'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
                             MOVWF   PCLATH
    MOVF    NR_HELP, W  ; SPRUNGDISTANZ
    ADDWF   PCL,F       ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  

    
;----------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------
        
;JETZT KOMMT DER TEXT
;RETLW " "    (SPACE/LEERZEICHEN) IST DIE PAUSE ZWISCHEN DEN WOERTERN


    RETLW "W"  
    RETLW 0X65 ;E
    RETLW 0X63 ;C
    RETLW 0X6B ;K
    RETLW "-"
    RETLW "A"
    RETLW 0X6C ;L
    RETLW 0X61 ;A
    RETLW 0X72 ;R
    RETLW 0X6D ;M
 
    RETLW " "
    
    ;RETLW 0X69 ;I 
    ;RETLW 0X73 ;S
    ;RETLW 0X74 ;T
    
    ;RETLW " "

    ;RETLW 0X6A ;J
    ;RETLW 0X65 ;E    
    ;RETLW 0X74 ;T
    ;RETLW 0X7A ;Z
    ;RETLW 0X74 ;T

    ;RETLW " "

    RETLW "A"
    RETLW "K"    
    RETLW "T"
    RETLW "I"    
    RETLW "V"    
    ;RETLW "."
 
    RETLW " "    
    RETLW " "    
    RETLW " "
    RETLW " "
    RETLW " "
    
    ;RETLW " "    
    ;RETLW " "    
    
    RETLW 0XFF
      
;*****************************************************************************
;*                              UNTERPROGRAMM                                *
;*                       TEXT ZEILENWEISE LADEN                              *
;*****************************************************************************
TEXT_7
                             MOVLW   H'0D'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
                             MOVWF   PCLATH
    MOVF    NR_HELP, W  ; SPRUNGDISTANZ
    ADDWF   PCL,F       ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  

    
;----------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------
        
;JETZT KOMMT DER TEXT
;RETLW " "    (SPACE/LEERZEICHEN) IST DIE PAUSE ZWISCHEN DEN WOERTERN


    RETLW "W"  
    RETLW 0X65 ;E
    RETLW 0X63 ;C
    RETLW 0X6B ;K
    RETLW "-"
    RETLW "A"
    RETLW 0X6C ;L
    RETLW 0X61 ;A
    RETLW 0X72 ;R
    RETLW 0X6D ;M
 
    RETLW " "
    
    ;RETLW 0X69 ;I 
    ;RETLW 0X73 ;S
    ;RETLW 0X74 ;T
    
    ;RETLW " "

    ;RETLW 0X6A ;J
    ;RETLW 0X65 ;E    
    ;RETLW 0X74 ;T
    ;RETLW 0X7A ;Z
    ;RETLW 0X74 ;T

    ;RETLW " "

    RETLW "N"
    RETLW "I"
    RETLW "C"
    RETLW "H"   
    RETLW "T"
    RETLW " "    
    ;RETLW "!"
    
    ;RETLW " " 
    
    RETLW "A"
    RETLW "K"    
    RETLW "T"
    RETLW "I"    
    RETLW "V"    
    ;RETLW "."
 
    RETLW " "    
    RETLW " "    
    RETLW " "
    RETLW " "
    RETLW " "    
    
    ;RETLW " "    
    ;RETLW " "    
    
    RETLW 0XFF   
    
        ORG 0X0E00
;*****************************************************************************
;*                              UNTERPROGRAMM                                *
;*                       TEXT ZEILENWEISE LADEN                              *
;*****************************************************************************
TEXT_1
                  MOVLW   H'0E'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
                  MOVWF   PCLATH
    MOVF    NR_HELP, W  ; SPRUNGDISTANZ
    ADDWF   PCL,F       ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  

    
;----------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------
        
;JETZT KOMMT DER TEXT
;RETLW " "    (SPACE/LEERZEICHEN) IST DIE PAUSE ZWISCHEN DEN WOERTERN

    ;RETLW "D"  
    ;RETLW 0X69 ;I
    ;RETLW 0X65 ;E
    ;RETLW 0X73 ;S
    ;RETLW 0X65 ;E
   
    ;RETLW " "
    
    RETLW "Z"
    RETLW 0X65 ;E
    RETLW 0X69 ;I
    RETLW 0X74 ;T
    RETLW "-"
    RETLW "Z"           
    RETLW 0X6F ;O    
    RETLW 0X6E ;N           
    RETLW 0X65 ;E
    
    RETLW " "
    
    ;RETLW 0X69 ;I 
    ;RETLW 0X73 ;S
    ;RETLW 0X74 ;T
    
    ;RETLW " "

    ;RETLW 0X6A ;J
    ;RETLW 0X65 ;E    
    ;RETLW 0X74 ;T
    ;RETLW 0X7A ;Z
    ;RETLW 0X74 ;T

    ;RETLW " "
    
    ;RETLW 0X65 ;E
    ;RETLW 0X69 ;I           
    ;RETLW 0X6E ;N    
    ;RETLW 0X67 ;G           
    ;RETLW 0X65 ;E
    ;RETLW 0X73 ;S
    ;RETLW 0X74 ;T
    ;RETLW 0X65 ;E
    ;RETLW 0X6C ;L
    ;RETLW 0X6C ;L           
    ;RETLW 0X74 ;T         
    
    ;RETLW "."
    
    ;RETLW " "
    
    ;RETLW "M"
    ;RETLW 0X61 ;A           
    ;RETLW 0X6E ;N
    
    ;RETLW " "
    
    ;RETLW 0X6B ;K
    ;RETLW 0X94 ;
    ;RETLW 0X6E ;N
    ;RETLW 0X6E ;N
    ;RETLW 0X74 ;T
    ;RETLW 0X65 ;E
    ;RETLW " "
        
    ;RETLW 0X84 ;
    ;RETLW 0X6E ;N           
    ;RETLW 0X64 ;D    
    ;RETLW 0X65 ;E           
    ;RETLW 0X72 ;R
    ;RETLW 0X6E ;N

    ;RETLW 0X21 ;!

    RETLW " "    
    RETLW " "    
    RETLW " "
    RETLW " "
    RETLW " "    
    
    ;RETLW " "    
    ;RETLW " "    
    
    RETLW 0XFF

;*****************************************************************************
;*                              UNTERPROGRAMM                                *
;*                       TEXT ZEILENWEISE LADEN                              *
;*****************************************************************************
TEXT_4
                  MOVLW   H'0E'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
                  MOVWF   PCLATH
    MOVF    NR_HELP, W  ; SPRUNGDISTANZ
    ADDWF   PCL,F       ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  

    
;----------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------
        
;JETZT KOMMT DER TEXT
;RETLW " "    (SPACE/LEERZEICHEN) IST DIE PAUSE ZWISCHEN DEN WOERTERN

    RETLW "W"  
    RETLW 0X65 ;E
    RETLW 0X63 ;C
    RETLW 0X6B ;K
    RETLW "-"
    RETLW "T"  
    RETLW 0X6F ;O
    RETLW 0X6E ;N

    RETLW " "

    ;RETLW 0X77 ;W
    ;RETLW 0X75 ;U
    ;RETLW 0X72 ;R
    ;RETLW 0X64 ;D
    ;RETLW 0X65 ;E
    
    ;RETLW " "
    
    ;RETLW 0X76 ;V
    ;RETLW 0X6F ;O
    ;RETLW 0X72 ;R
    ;RETLW 0X7A ;Z
    ;RETLW 0X65 ;E
    ;RETLW 0X69 ;I
    ;RETLW 0X74 ;T
    ;RETLW 0X69 ;I
    ;RETLW 0X67 ;G
     
    ;RETLW " "
    
    RETLW 0X62 ;B    
    RETLW 0X65 ;E    
    RETLW 0X65 ;E
    RETLW 0X6E ;N
    RETLW 0X64 ;D
    RETLW 0X65 ;E
    RETLW 0X74 ;T
    
    ;RETLW "." 
    
    RETLW " "    
    RETLW " "    
    RETLW " "
    RETLW " "
    RETLW " "    
    
    ;RETLW " "    
    ;RETLW " "    
    
    RETLW 0XFF
                       END






